﻿namespace Microsoft.Xna.GameStudio
{
    using System;
    using System.ComponentModel.Design;

    internal static class CmdIDConstants
    {
        internal static readonly CommandID AddClassCmdID = new CommandID(VsMenus.guidStandardCommandSet97, 0x3b2);
        internal static readonly CommandID AddComponentCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x1ba);
        internal static readonly CommandID AddContentReferenceCmdID = new CommandID(GuidXnaPackageCmdSet, 0x121);
        internal static readonly CommandID AddDataSourceCmdID = new CommandID(dataMenuGuid, 0x209);
        internal static readonly CommandID AddReferenceCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x459);
        internal static readonly CommandID AddReferenceCtxCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x465);
        internal static readonly CommandID AddServiceReferenceCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x469);
        internal static readonly CommandID AddServiceReferenceCtxCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x46a);
        internal static readonly CommandID AddUserControlCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x19c);
        internal static readonly CommandID AddWebReferenceCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x45a);
        internal static readonly CommandID AddWebReferenceCtxCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x45b);
        internal static readonly CommandID AddWinFormCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x196);
        internal static readonly CommandID buttonAddDeviceID = new CommandID(GuidXnaPackageCmdSet, 0x115);
        internal static readonly CommandID buttonLaunchDevCenterCommandID = new CommandID(GuidXnaPackageCmdSet, 0x114);
        internal static readonly CommandID CalculateCodeMetricsCmdID = new CommandID(guidCalculateCodeMetricsCmdSet, 0x403);
        internal static readonly CommandID CalculateCodeMetricsCtxCmdID = new CommandID(guidCalculateCodeMetricsCmdSet, 0x300);
        internal static readonly CommandID CalculateCodeMetricsCtxMultiCmdID = new CommandID(guidCalculateCodeMetricsCmdSet, 0x303);
        internal static readonly CommandID comboBoxCommandID = new CommandID(GuidXnaPackageCmdSet, 0x111);
        internal static readonly CommandID comboBoxFillCommandID = new CommandID(GuidXnaPackageCmdSet, 0x112);
        internal static CommandID[] ContentProjectCommandsToFilter = new CommandID[] { 
            AddServiceReferenceCmdID, AddServiceReferenceCtxCmdID, AddWebReferenceCmdID, AddWebReferenceCtxCmdID, AddUserControlCmdID, AddWinFormCmdID, AddClassCmdID, AddComponentCmdID, ViewClassDiagramCmdID, PublishCmdID, PublishSlnCtxCmdID, AddDataSourceCmdID, ShowDataSourceCmdID, GenerateTestsEditorCmdID, CreateAccessorCmdID, CreateAccessorMenuID, 
            SetStartupProjectCmdID, RunCodeAnalysisCmdID, RunCodeAnalysisCtxCmdID, CalculateCodeMetricsCmdID, CalculateCodeMetricsCtxCmdID, CalculateCodeMetricsCtxMultiCmdID
         };
        internal static readonly CommandID CreateAccessorCmdID = new CommandID(guidVSEQTPackageCmdSet, 0x3202);
        internal static readonly CommandID CreateAccessorMenuID = new CommandID(guidVSEQTPackageCmdSet, 0x130c);
        private static readonly Guid dataMenuGuid = new Guid("{746910da-3a87-4255-a4ae-d1083b0572a0}");
        internal static CommandID[] DeviceProjectCommandsToFilter = new CommandID[] { AddUserControlCmdID, AddWinFormCmdID, AddComponentCmdID, PublishCmdID, PublishSlnCtxCmdID, AddDataSourceCmdID, ShowDataSourceCmdID, GenerateTestsEditorCmdID, CreateAccessorCmdID, CreateAccessorMenuID };
        private const int ECMD_CALCCODEMETRICS = 0x403;
        private const int ECMD_CALCCODEMETRICSCTX = 0x300;
        private const int ECMD_CALCCODEMETRICSCTXMULTI = 0x303;
        private const int ECMD_RUNFXCOPPROJCTX = 0x670;
        private const int ECMD_RUNFXCOPSEL = 0x66f;
        internal static readonly CommandID GenerateTestsEditorCmdID = new CommandID(guidVSEQTPackageCmdSet, 0x3201);
        internal static readonly Guid guidCalculateCodeMetricsCmdSet = new Guid("79989DD6-4C13-4D10-9872-73538668D037");
        internal static readonly Guid guidDeviceManagementToolbarVisibility = new Guid("94EC5E37-E579-47ba-8B8D-0B8F769FCABB");
        private static readonly Guid guidVSEQTPackageCmdSet = new Guid("B85579AA-8BE0-4c4f-A850-90902B317571");
        internal static readonly Guid GuidXnaPackageCmdSet = new Guid("0EB1343D-5952-473c-A28F-F57352691FF1");
        private const int icmdCreateAccessor = 0x3202;
        private const int icmdGenerateTestsEditor = 0x3201;
        private const int imnuCreateAccessor = 0x130c;
        internal static CommandID[] OnlyRootCommandsToFilter = new CommandID[] { CalculateCodeMetricsCtxMultiCmdID };
        internal static readonly CommandID PublishCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x7d5);
        internal static readonly CommandID PublishSlnCtxCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x7d6);
        internal static readonly CommandID RunCodeAnalysisCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x66f);
        internal static readonly CommandID RunCodeAnalysisCtxCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x670);
        internal static readonly CommandID SetStartupProjectCmdID = new CommandID(VsMenus.guidStandardCommandSet97, 0xf6);
        internal static readonly CommandID ShowDataSourceCmdID = new CommandID(dataMenuGuid, 520);
        internal static readonly CommandID ViewClassDiagramCmdID = new CommandID(VsMenus.guidStandardCommandSet2K, 0x78b);
        internal static readonly CommandID XnaCloneForWindowsCmdID = new CommandID(GuidXnaPackageCmdSet, 0x200);
        internal static readonly CommandID XnaCloneForWindowsCtxCmdID = new CommandID(GuidXnaPackageCmdSet, 0x300);
        internal static readonly CommandID XnaCloneForWindowsPhoneCmdID = new CommandID(GuidXnaPackageCmdSet, 0x202);
        internal static readonly CommandID XnaCloneForWindowsPhoneCtxCmdID = new CommandID(GuidXnaPackageCmdSet, 770);
        internal static readonly CommandID XnaCloneForXbox360CmdID = new CommandID(GuidXnaPackageCmdSet, 0x201);
        internal static readonly CommandID XnaCloneForXbox360CtxCmdID = new CommandID(GuidXnaPackageCmdSet, 0x301);
        internal static readonly CommandID XnaPackageCmdID = new CommandID(GuidXnaPackageCmdSet, 0x101);
        internal static readonly CommandID XnaPackageCtxCmdID = new CommandID(GuidXnaPackageCmdSet, 0x102);
        internal static readonly CommandID XnaUpgradeSolutionCmdID = new CommandID(GuidXnaPackageCmdSet, 0x203);
        internal static readonly CommandID XnaUpgradeSolutionCtxCmdID = new CommandID(GuidXnaPackageCmdSet, 0x303);
    }
}

