﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using EnvDTE;
    using Microsoft.Xna.GameStudio;
    using System;
    using System.Diagnostics.CodeAnalysis;
    using System.Runtime.InteropServices;

    [SuppressMessage("Microsoft.Interoperability", "CA1409:ComVisibleTypesShouldBeCreatable"), Guid("31BEAF76-3C27-415B-8CBE-B323391131C6"), ClassInterface(ClassInterfaceType.AutoDispatch), ComVisible(true)]
    public sealed class ClickOnceProjectExtender : AutomationExtender, IClickOnceProjectExtender
    {
        private string[] bootstrapperPackages;

        internal ClickOnceProjectExtender(string[] bootstrapperPackages, object extendeeObject, IExtenderSite site, int cookie) : base(extendeeObject, site, cookie)
        {
            if (bootstrapperPackages == null)
            {
                throw new ArgumentNullException("bootstrapperPackages");
            }
            this.bootstrapperPackages = bootstrapperPackages;
        }

        public string[] GetBootstrapperPackages()
        {
            return (string[]) this.bootstrapperPackages.Clone();
        }
    }
}

