﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using EnvDTE;
    using Microsoft.Xna.GameStudio;
    using System;

    internal class ClickOnceProjectExtenderProvider : InternalExtenderProvider<ClickOnceProjectExtender>
    {
        private string[] bootstrapperPackages;

        internal ClickOnceProjectExtenderProvider(string bootstrapperPackage)
        {
            if (bootstrapperPackage == null)
            {
                throw new ArgumentNullException("bootstrapperPackage");
            }
            this.bootstrapperPackages = new string[] { bootstrapperPackage };
        }

        public override bool CanExtend(string ExtenderCATID, string ExtenderName, object ExtendeeObject)
        {
            if (ExtenderCATID == null)
            {
                throw new ArgumentNullException("ExtenderCATID");
            }
            if (ExtenderName == null)
            {
                throw new ArgumentNullException("ExtenderName");
            }
            if (ExtendeeObject == null)
            {
                throw new ArgumentNullException("ExtendeeObject");
            }
            return ((string.CompareOrdinal(ExtenderCATID, "{610D4614-D0D5-11D2-8599-006097C68E81}") == 0) && (string.CompareOrdinal(ExtenderName, base.Name) == 0));
        }

        protected override ClickOnceProjectExtender CreateExtender(string ExtenderCATID, string ExtenderName, object ExtendeeObject, IExtenderSite ExtenderSite, int Cookie)
        {
            return new ClickOnceProjectExtender(this.bootstrapperPackages, ExtendeeObject, ExtenderSite, Cookie);
        }
    }
}

