﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using System;
    using System.Collections;
    using System.Drawing;
    using System.Windows.Forms;

    internal static class ComboBoxUtils
    {
        private static int MeasureMaxTextWidth(Control control, IEnumerable items)
        {
            if (control == null)
            {
                throw new ArgumentNullException("control");
            }
            if (items == null)
            {
                throw new ArgumentNullException("items");
            }
            int num = 0;
            using (Graphics graphics = control.CreateGraphics())
            {
                foreach (object obj2 in items)
                {
                    string text = "";
                    if (obj2 == null)
                    {
                        text = "";
                    }
                    else
                    {
                        string str2 = obj2 as string;
                        if (str2 != null)
                        {
                            text = str2;
                        }
                        else
                        {
                            text = obj2.ToString();
                        }
                    }
                    int width = (int) graphics.MeasureString(text, control.Font).Width;
                    num = Math.Max(num, width);
                }
            }
            return num;
        }

        internal static void SetComboBoxDropdownWidth(ComboBox comboBox)
        {
            if (comboBox == null)
            {
                throw new ArgumentNullException("comboBox");
            }
            comboBox.DropDownWidth = Math.Max(MeasureMaxTextWidth(comboBox, comboBox.Items), comboBox.Width);
        }
    }
}

