﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using Microsoft.VisualStudio.Shell.Interop;
    using Microsoft.Xna.GameStudio;
    using System;
    using System.Collections.Generic;

    internal interface IXnaCodeProject
    {
        event EventHandler BuildStatusChanged;

        event EventHandler<ProjectDocumentsChangeEventArgs> FileAdded;

        event EventHandler<ProjectDocumentsChangeEventArgs> FileRemoved;

        event EventHandler<ProjectDocumentsRenamedEventArgs> FileRenamed;

        event EventHandler ThumbnailChanged;

        void DoPackaging(bool shouldPackage);
        string GetBuildProperty(string propertyName, string configurationName);
        string GetFullThumbnailPath();
        string GetSolutionDir();
        IEnumerable<uint> GetVisibleItems();
        IVsHierarchy GetVsHierarchy();
        object GetVsService(Type service);
        bool InDeleteItem();
        void SyncDirectoryRemove(string dirpath);
        void SyncDirectoryRename(string oldDirpath, string newDirpath);
        void SyncFileAdd(string filepath, Dictionary<string, object> properties);
        void SyncFileRemove(string filepath);
        void SyncFileRename(string oldFilepath, string newFilepath);

        IProjectPlatformAdapter Adapter { get; }

        string CrossPlatformGroupID { get; set; }

        XnaErrorProvider ErrorProvider { get; }

        Microsoft.Xna.GameStudio.CodeProject.HierarchyItemManager HierarchyItemManager { get; }

        IVsHierarchy InnerIVsHierarchy { get; }

        IVsUIHierarchy InnerIVsUIHierarchy { get; }

        IVsBuildPropertyStorage InnerVsBuildPropertyStorage { get; }

        IVsProject InnerVsProject { get; }

        bool IsBuilding { get; }

        bool IsEntryProject { get; }

        bool IsNewProject { get; }

        IEnumerable<KeyValuePair<string, string>> KnownProjectPlatformAdapters { get; }

        IProjectLanguageAdapter LanguageAdapter { get; }

        string[] SdkPaths { get; }

        bool ShowProjectInSolutionPage { get; set; }

        string TargetFrameworkMoniker { get; }

        string Thumbnail { get; set; }

        string XnaFrameworkVersion { get; }
    }
}

