﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using Microsoft.VisualStudio;
    using Microsoft.Xna.GameStudio;
    using System;
    using System.Runtime.InteropServices;

    internal class ReferencesFolderNode : HierarchyItem
    {
        private IXnaCodeProject codeProject;
        private uint itemid;

        internal ReferencesFolderNode(uint itemid, IXnaCodeProject codeProject) : base(codeProject.InnerIVsUIHierarchy)
        {
            this.itemid = itemid;
            this.codeProject = codeProject;
            base.OverrideProperty(-1001, new HierarchyItem.GetPropertyDelegate(this.GetFirstChild));
            base.OverrideProperty(-2041, new HierarchyItem.GetPropertyDelegate(this.GetFirstChild));
            base.OverrideProperty(-1002, new HierarchyItem.GetPropertyDelegate(this.GetNextSibling));
            base.OverrideProperty(-2042, new HierarchyItem.GetPropertyDelegate(this.GetNextSibling));
        }

        private int GetFirstChild(uint itemid, int propid, out object property)
        {
            HierarchyItemManager hierarchyItemManager = this.codeProject.HierarchyItemManager;
            int hr = base.InnerHierarchy.GetProperty(itemid, propid, out property);
            if (ErrorHandler.Succeeded(hr))
            {
                int num2 = (propid == -1001) ? -1002 : -2042;
                while (hierarchyItemManager.IsManagedItem((uint) ((int) property)))
                {
                    hr = base.InnerHierarchy.GetProperty((uint) ((int) property), num2, out property);
                    if (ErrorHandler.Failed(hr))
                    {
                        return hr;
                    }
                }
            }
            return hr;
        }

        private int GetNextSibling(uint itemid, int propid, out object property)
        {
            HierarchyItemManager hierarchyItemManager = this.codeProject.HierarchyItemManager;
            if (hierarchyItemManager.IsContentReferencesFolderNodeVisible() && (hierarchyItemManager.ItemBeforeContentReferencesFolder == itemid))
            {
                property = (int) hierarchyItemManager.ContentReferencesFolderNode.GetItemId();
                return 0;
            }
            return base.InnerHierarchy.GetProperty(itemid, propid, out property);
        }

        internal uint Itemid
        {
            get
            {
                return this.itemid;
            }
        }
    }
}

