﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using Microsoft.Xna.GameStudio;
    using Microsoft.Xna.GameStudio.RegistrationAttributes;
    using Microsoft.Xna.GameStudio.Resources;
    using System;
    using System.Drawing;
    using System.Runtime.InteropServices;

    [Guid("ACC99C20-0FB7-416F-B78C-373971FA6C9D"), ProjectType(typeof(UnsupportedVersionAdapter), typeof(XnaPackage), null, null, null, null, null, LanguageVsTemplate="CSharp")]
    public sealed class UnsupportedVersionAdapter : BasePlatformAdapter
    {
        private string unsupportedFrameworkVerion;
        private string unsupportedPlatform;
        private const string unsupportedPlatformVersion = "Unsupported";

        internal UnsupportedVersionAdapter(string xnaPlatform, string xnaFrameworkVersion)
        {
            if (xnaPlatform == null)
            {
                throw new ArgumentNullException("xnaPlatform");
            }
            if (xnaFrameworkVersion == null)
            {
                throw new ArgumentNullException("xnaFrameworkVersion");
            }
            this.unsupportedPlatform = xnaPlatform;
            this.unsupportedFrameworkVerion = xnaFrameworkVersion;
        }

        public override Microsoft.Xna.GameStudio.CodeProject.HelpContextFilters HelpContextFilters
        {
            get
            {
                return null;
            }
        }

        public override bool IsDevicePlatform
        {
            get
            {
                return false;
            }
        }

        public override string PlatformConstants
        {
            get
            {
                return "Unsupported";
            }
        }

        public override Bitmap ProjectNodeIcon
        {
            get
            {
                return XnaProjectResource._303;
            }
        }

        public override Guid ProjectTypeGuid
        {
            get
            {
                return base.GetType().GUID;
            }
        }

        public override string XnaFrameworkRuntimeProfile
        {
            get
            {
                return "Unsupported";
            }
        }

        public override string XnaFrameworkVersion
        {
            get
            {
                return this.unsupportedFrameworkVerion;
            }
        }

        public override string XnaPlatform
        {
            get
            {
                return this.unsupportedPlatform;
            }
        }
    }
}

