﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using EnvDTE;
    using Microsoft.VisualStudio;
    using Microsoft.VisualStudio.Shell.Interop;
    using Microsoft.Xna.GameStudio;
    using Microsoft.Xna.GameStudio.Resources;
    using System;
    using System.ComponentModel;
    using System.Diagnostics.CodeAnalysis;
    using System.Runtime.InteropServices;

    [ClassInterface(ClassInterfaceType.AutoDispatch), SuppressMessage("Microsoft.Interoperability", "CA1409:ComVisibleTypesShouldBeCreatable"), ComVisible(true), Guid("4F83E5ED-E6A4-4C1F-9634-D5F18573A720")]
    public sealed class WindowsPhoneProjectPropertiesExtender : AutomationExtender
    {
        private IVsBuildPropertyStorage buildPropStorage;

        internal WindowsPhoneProjectPropertiesExtender(object extendeeObject, IExtenderSite site, int cookie) : base(extendeeObject, site, cookie)
        {
        }

        private void Initialize()
        {
            IVsBrowseObject obj2 = base.Object as IVsBrowseObject;
            if ((this.buildPropStorage == null) && (obj2 != null))
            {
                IVsHierarchy pHier = null;
                uint maxValue = uint.MaxValue;
                ErrorHandler.ThrowOnFailure(obj2.GetProjectItem(out pHier, out maxValue));
                this.buildPropStorage = pHier as IVsBuildPropertyStorage;
            }
        }

        [XnaDescription("XNARefreshLevelDescription"), XnaDisplayName("XNARefreshLevel"), Category("XNA Framework")]
        public string XnaRefreshLevel
        {
            get
            {
                if (this.buildPropStorage == null)
                {
                    this.Initialize();
                }
                string wPXnaRefreshLevelUnknown = XnaProjectResource.WPXnaRefreshLevelUnknown;
                if (this.buildPropStorage == null)
                {
                    return wPXnaRefreshLevelUnknown;
                }
                string pbstrPropValue = string.Empty;
                if (ErrorHandler.Succeeded(this.buildPropStorage.GetPropertyValue("XnaRefreshLevel", null, 1, out pbstrPropValue)))
                {
                    if ("0".Equals(pbstrPropValue, StringComparison.OrdinalIgnoreCase) || string.IsNullOrEmpty(pbstrPropValue))
                    {
                        return XnaProjectResource.WPXnaRefreshLevelZero;
                    }
                    if (pbstrPropValue.Equals("1", StringComparison.OrdinalIgnoreCase))
                    {
                        return XnaProjectResource.WPXnaRefreshLevelOne;
                    }
                    return XnaProjectResource.WPXnaRefreshLevelUnknown;
                }
                return XnaProjectResource.WPXnaRefreshLevelZero;
            }
        }
    }
}

