﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using EnvDTE;
    using Microsoft.VisualStudio.Shell.Interop;
    using Microsoft.Xna.GameStudio;
    using System;

    internal class WindowsPhoneProjectPropertiesExtenderProvider : InternalExtenderProvider<WindowsPhoneProjectPropertiesExtender>
    {
        public override bool CanExtend(string ExtenderCATID, string ExtenderName, object ExtendeeObject)
        {
            if (ExtenderCATID == null)
            {
                throw new ArgumentNullException("ExtenderCATID");
            }
            if (ExtenderName == null)
            {
                throw new ArgumentNullException("ExtenderName");
            }
            if (ExtendeeObject == null)
            {
                throw new ArgumentNullException("ExtendeeObject");
            }
            return (ExtenderName.Equals(base.Name, StringComparison.OrdinalIgnoreCase) && ((ExtendeeObject is IVsBrowseObject) || (ExtendeeObject is IVsCfgBrowseObject)));
        }

        protected override WindowsPhoneProjectPropertiesExtender CreateExtender(string ExtenderCATID, string ExtenderName, object ExtendeeObject, IExtenderSite ExtenderSite, int Cookie)
        {
            return new WindowsPhoneProjectPropertiesExtender(ExtendeeObject, ExtenderSite, Cookie);
        }
    }
}

