﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using EnvDTE;
    using Microsoft.Xna.GameStudio;
    using System;
    using System.Diagnostics.CodeAnalysis;
    using System.Runtime.InteropServices;

    [ClassInterface(ClassInterfaceType.None), SuppressMessage("Microsoft.Interoperability", "CA1409:ComVisibleTypesShouldBeCreatable"), ComVisible(true), Guid("105541C5-9129-48f0-B508-17EEBE031319")]
    public sealed class XnaFilterPropertiesExtender : AutomationExtender
    {
        private string[] propertyNames;

        internal XnaFilterPropertiesExtender(object extendeeObject, IExtenderSite extenderSite, int cookie, string[] projectSpecificFilterProperties) : base(extendeeObject, extenderSite, cookie)
        {
            string[] sourceArray = projectSpecificFilterProperties;
            if (sourceArray == null)
            {
                sourceArray = new string[0];
            }
            string[] strArray2 = new string[0];
            this.propertyNames = new string[sourceArray.Length + strArray2.Length];
            Array.Copy(sourceArray, this.propertyNames, sourceArray.Length);
            Array.Copy(strArray2, 0, this.propertyNames, sourceArray.Length, strArray2.Length);
            Array.Sort<string>(this.propertyNames);
        }

        public override vsFilterProperties IsPropertyHidden(string PropertyName)
        {
            if ((PropertyName != null) && (Array.BinarySearch<string>(this.propertyNames, PropertyName) >= 0))
            {
                return vsFilterProperties.vsFilterPropertiesAll;
            }
            return base.IsPropertyHidden(PropertyName);
        }
    }
}

