﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using EnvDTE;
    using Microsoft.VisualStudio.Shell.Interop;
    using Microsoft.Xna.GameStudio;
    using System;
    using System.Linq;

    internal sealed class XnaFilterPropertiesExtenderProvider : InternalExtenderProvider<XnaFilterPropertiesExtender>
    {
        private IXnaCodeProject project;

        internal XnaFilterPropertiesExtenderProvider(IXnaCodeProject project)
        {
            if (project == null)
            {
                throw new ArgumentNullException("project");
            }
            this.project = project;
        }

        public override bool CanExtend(string ExtenderCATID, string ExtenderName, object ExtendeeObject)
        {
            if (ExtenderCATID == null)
            {
                throw new ArgumentNullException("ExtenderCATID");
            }
            if (ExtenderName == null)
            {
                throw new ArgumentNullException("ExtenderName");
            }
            if (ExtendeeObject == null)
            {
                throw new ArgumentNullException("ExtendeeObject");
            }
            return ((((string.CompareOrdinal(ExtenderCATID, this.project.LanguageAdapter.ProjectBrowseObjectGuidString) == 0) && (string.CompareOrdinal(ExtenderName, base.Name) == 0)) && (ExtendeeObject is IVsBrowseObject)) || (((string.CompareOrdinal(ExtenderCATID, this.project.LanguageAdapter.ProjectConfigBrowseObjectGuidString) == 0) && (string.CompareOrdinal(ExtenderName, base.Name) == 0)) && (ExtendeeObject is IVsCfgBrowseObject)));
        }

        protected override XnaFilterPropertiesExtender CreateExtender(string ExtenderCATID, string ExtenderName, object ExtendeeObject, IExtenderSite ExtenderSite, int Cookie)
        {
            return new XnaFilterPropertiesExtender(ExtendeeObject, ExtenderSite, Cookie, this.project.LanguageAdapter.PropertyPageHandler.FilterAndTranslateProperties(this.project.Adapter.GetFilterProperties()).ToArray<string>());
        }
    }
}

