﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using EnvDTE;
    using Microsoft.Xna.GameStudio;
    using System;
    using System.ComponentModel;
    using System.Diagnostics.CodeAnalysis;
    using System.Runtime.InteropServices;

    [Guid("8DF6119E-6EE5-43f2-BCC6-71DB1F2F0784"), SuppressMessage("Microsoft.Interoperability", "CA1409:ComVisibleTypesShouldBeCreatable"), ComVisible(true), ClassInterface(ClassInterfaceType.AutoDispatch)]
    public sealed class XnaProjectPropertiesExtender : AutomationExtender, IXnaProjectPropertiesExtender
    {
        private string platform;
        private string version;

        internal XnaProjectPropertiesExtender(string platform, string version, object extendeeObject, IExtenderSite site, int cookie) : base(extendeeObject, site, cookie)
        {
            if (platform == null)
            {
                throw new ArgumentNullException("platform");
            }
            if (version == null)
            {
                throw new ArgumentNullException("version");
            }
            this.platform = platform;
            this.version = version;
        }

        [Category("XNA Framework"), XnaDisplayName("XNAPlatform"), XnaDescription("XNAPlatformDescription")]
        public string XnaPlatform
        {
            get
            {
                return this.platform;
            }
        }

        [XnaDescription("XNAVersionDescription"), XnaDisplayName("XNAVersion"), Category("XNA Framework")]
        public string XnaVersion
        {
            get
            {
                return this.version;
            }
        }
    }
}

