﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using EnvDTE;
    using Microsoft.Xna.GameStudio;
    using System;
    using System.Runtime.InteropServices;

    [Guid("B9A1AE56-FC0E-473c-B828-0A769E5F7D22")]
    internal sealed class XnaProjectPropertiesExtenderProvider : InternalExtenderProvider<XnaProjectPropertiesExtender>
    {
        private IXnaCodeProject project;

        public XnaProjectPropertiesExtenderProvider(IXnaCodeProject project)
        {
            if (project == null)
            {
                throw new ArgumentNullException("project");
            }
            this.project = project;
        }

        public override bool CanExtend(string ExtenderCATID, string ExtenderName, object ExtendeeObject)
        {
            if (ExtenderCATID == null)
            {
                throw new ArgumentNullException("ExtenderCATID");
            }
            if (ExtenderName == null)
            {
                throw new ArgumentNullException("ExtenderName");
            }
            if (ExtendeeObject == null)
            {
                throw new ArgumentNullException("ExtendeeObject");
            }
            return (((string.CompareOrdinal(ExtenderCATID, this.project.LanguageAdapter.ProjectBrowseObjectGuidString) == 0) || (string.Compare(ExtenderCATID, "{610D4614-D0D5-11D2-8599-006097C68E81}", StringComparison.OrdinalIgnoreCase) == 0)) && (string.CompareOrdinal(ExtenderName, base.Name) == 0));
        }

        protected override XnaProjectPropertiesExtender CreateExtender(string ExtenderCATID, string ExtenderName, object ExtendeeObject, IExtenderSite ExtenderSite, int Cookie)
        {
            return new XnaProjectPropertiesExtender(this.project.Adapter.XnaPlatform, this.project.XnaFrameworkVersion, ExtendeeObject, ExtenderSite, Cookie);
        }
    }
}

