﻿namespace Microsoft.Xna.GameStudio.ContentProject
{
    using Microsoft.Xna.GameStudio;
    using Microsoft.Xna.GameStudio.Resources;
    using System;
    using System.Drawing;
    using System.Runtime.InteropServices;
    using System.Windows.Forms;

    [ComVisible(true), ClassInterface(ClassInterfaceType.None), Guid("B03E533C-4746-4046-8610-D84C3F0BC68F")]
    internal class ContentBuildPropertyPage : ProjectDesignerPropertyPage
    {
        private Label errorLabel;

        public ContentBuildPropertyPage() : base(XnaProjectResource.BuildPropertyPageTabTitle, "XNA.ContentProject.Overview")
        {
        }

        public override bool FinishPendingValidations()
        {
            return true;
        }

        protected override void OnCommitPropertyEdit()
        {
        }

        public override bool SupportsMultipleValueUndo(string propertyName)
        {
            return false;
        }

        protected override Control PageView
        {
            get
            {
                if (this.errorLabel == null)
                {
                    this.errorLabel = new Label();
                    this.errorLabel.AutoSize = true;
                    this.errorLabel.TextAlign = ContentAlignment.MiddleCenter;
                    this.errorLabel.Dock = DockStyle.Fill;
                    this.errorLabel.Text = XnaProjectResource.ContentBuildPropertyPageLabel;
                }
                return this.errorLabel;
            }
        }
    }
}

