﻿namespace Microsoft.Xna.GameStudio.ContentProject
{
    using EnvDTE;
    using Microsoft.Xna.GameStudio;
    using System;

    internal class ContentRootDirectoryExtenderProvider : InternalExtenderProvider<ContentRootDirectoryExtender>
    {
        private IXnaContentProject xnaContentProject;

        internal ContentRootDirectoryExtenderProvider(IXnaContentProject xnaContentProject)
        {
            if (xnaContentProject == null)
            {
                throw new ArgumentNullException("xnaContentProject");
            }
            this.xnaContentProject = xnaContentProject;
        }

        public override bool CanExtend(string ExtenderCATID, string ExtenderName, object ExtendeeObject)
        {
            return ContentRootDirectoryExtender.CanExtend(ExtenderCATID);
        }

        protected override ContentRootDirectoryExtender CreateExtender(string ExtenderCATID, string ExtenderName, object ExtendeeObject, IExtenderSite ExtenderSite, int Cookie)
        {
            return new ContentRootDirectoryExtender(this.xnaContentProject, ExtendeeObject, ExtenderSite, Cookie);
        }
    }
}

