﻿namespace Microsoft.Xna.GameStudio.ContentProject
{
    using Microsoft.VisualStudio;
    using Microsoft.VisualStudio.OLE.Interop;
    using Microsoft.VisualStudio.Shell.Interop;
    using Microsoft.Xna.GameStudio;
    using System;
    using System.Runtime.InteropServices;

    internal class NonDebuggableProjectCfg : IVsDebuggableProjectCfg2, IVsDebuggableProjectCfg, IVsProjectCfg, IVsCfg
    {
        private IVsDebuggableProjectCfg2 innerDebuggableCfg;
        private ProjectFlavorCfg projectFlavorCfg;

        internal NonDebuggableProjectCfg(ProjectFlavorCfg projectFlavorCfg, IVsDebuggableProjectCfg2 innerDebuggableCfg)
        {
            if (projectFlavorCfg == null)
            {
                throw new ArgumentNullException("projectFlavorCfg");
            }
            if (innerDebuggableCfg == null)
            {
                throw new ArgumentNullException("innerDebuggableCfg");
            }
            this.projectFlavorCfg = projectFlavorCfg;
            this.innerDebuggableCfg = innerDebuggableCfg;
        }

        public int DebugLaunch(uint grfLaunch)
        {
            throw new NotImplementedException();
        }

        public int EnumOutputs(out IVsEnumOutputs ppIVsEnumOutputs)
        {
            return this.innerDebuggableCfg.EnumOutputs(out ppIVsEnumOutputs);
        }

        public int get_BuildableProjectCfg(out IVsBuildableProjectCfg ppIVsBuildableProjectCfg)
        {
            ppIVsBuildableProjectCfg = null;
            IntPtr zero = IntPtr.Zero;
            try
            {
                Guid gUID = typeof(IVsBuildableProjectCfg).GUID;
                ErrorHandler.ThrowOnFailure(this.projectFlavorCfg.get_CfgType(ref gUID, out zero));
                ppIVsBuildableProjectCfg = (IVsBuildableProjectCfg) Marshal.GetObjectForIUnknown(zero);
            }
            finally
            {
                if (zero != IntPtr.Zero)
                {
                    Marshal.Release(zero);
                }
            }
            return 0;
        }

        public int get_CanonicalName(out string pbstrCanonicalName)
        {
            return this.innerDebuggableCfg.get_CanonicalName(out pbstrCanonicalName);
        }

        public int get_DisplayName(out string pbstrDisplayName)
        {
            return this.innerDebuggableCfg.get_DisplayName(out pbstrDisplayName);
        }

        public int get_IsDebugOnly(out int pfIsDebugOnly)
        {
            return this.innerDebuggableCfg.get_IsDebugOnly(out pfIsDebugOnly);
        }

        public int get_IsPackaged(out int pfIsPackaged)
        {
            return this.innerDebuggableCfg.get_IsPackaged(out pfIsPackaged);
        }

        public int get_IsReleaseOnly(out int pfIsReleaseOnly)
        {
            return this.innerDebuggableCfg.get_IsReleaseOnly(out pfIsReleaseOnly);
        }

        public int get_IsSpecifyingOutputSupported(out int pfIsSpecifyingOutputSupported)
        {
            return this.innerDebuggableCfg.get_IsSpecifyingOutputSupported(out pfIsSpecifyingOutputSupported);
        }

        public int get_Platform(out Guid pguidPlatform)
        {
            return this.innerDebuggableCfg.get_Platform(out pguidPlatform);
        }

        public int get_ProjectCfgProvider(out IVsProjectCfgProvider ppIVsProjectCfgProvider)
        {
            return this.innerDebuggableCfg.get_ProjectCfgProvider(out ppIVsProjectCfgProvider);
        }

        public int get_RootURL(out string pbstrRootURL)
        {
            return this.innerDebuggableCfg.get_RootURL(out pbstrRootURL);
        }

        public int get_TargetCodePage(out uint puiTargetCodePage)
        {
            return this.innerDebuggableCfg.get_TargetCodePage(out puiTargetCodePage);
        }

        public int get_UpdateSequenceNumber(ULARGE_INTEGER[] puliUSN)
        {
            return this.innerDebuggableCfg.get_UpdateSequenceNumber(puliUSN);
        }

        public int OnBeforeDebugLaunch(uint grfLaunch)
        {
            return this.innerDebuggableCfg.OnBeforeDebugLaunch(grfLaunch);
        }

        public int OpenOutput(string szOutputCanonicalName, out IVsOutput ppIVsOutput)
        {
            return this.innerDebuggableCfg.OpenOutput(szOutputCanonicalName, out ppIVsOutput);
        }

        public int QueryDebugLaunch(uint grfLaunch, out int pfCanLaunch)
        {
            pfCanLaunch = Convert.ToInt32(false);
            return 0;
        }
    }
}

