﻿namespace Microsoft.Xna.GameStudio.ContentProject
{
    using Microsoft.VisualStudio.OLE.Interop;
    using Microsoft.VisualStudio.Shell.Interop;
    using System;
    using System.Runtime.InteropServices;

    internal class ProjectCfg : IVsProjectCfg2, IVsProjectCfg, IVsCfg
    {
        private ProjectCfgProvider cfgProvider;
        private IVsProjectCfg2 innerProjectCfg2;

        public ProjectCfg(IVsProjectCfg2 innerProjectCfg2, ProjectCfgProvider cfgProvider)
        {
            if (innerProjectCfg2 == null)
            {
                throw new ArgumentNullException("innerProjectCfg2");
            }
            if (cfgProvider == null)
            {
                throw new ArgumentNullException("cfgProvider");
            }
            this.innerProjectCfg2 = innerProjectCfg2;
            this.cfgProvider = cfgProvider;
        }

        public int EnumOutputs(out IVsEnumOutputs ppIVsEnumOutputs)
        {
            return this.innerProjectCfg2.EnumOutputs(out ppIVsEnumOutputs);
        }

        public int get_BuildableProjectCfg(out IVsBuildableProjectCfg ppIVsBuildableProjectCfg)
        {
            ppIVsBuildableProjectCfg = null;
            return -2147467262;
        }

        public int get_CanonicalName(out string pbstrCanonicalName)
        {
            return this.innerProjectCfg2.get_CanonicalName(out pbstrCanonicalName);
        }

        public int get_CfgType(ref Guid iidCfg, out IntPtr ppCfg)
        {
            if ((iidCfg != typeof(IVsBuildableProjectCfg).GUID) && (iidCfg != typeof(IVsBuildableProjectCfg2).GUID))
            {
                return this.innerProjectCfg2.get_CfgType(ref iidCfg, out ppCfg);
            }
            ppCfg = IntPtr.Zero;
            return -2147467262;
        }

        public int get_DisplayName(out string pbstrDisplayName)
        {
            return this.innerProjectCfg2.get_DisplayName(out pbstrDisplayName);
        }

        public int get_IsDebugOnly(out int pfIsDebugOnly)
        {
            return this.innerProjectCfg2.get_IsDebugOnly(out pfIsDebugOnly);
        }

        public int get_IsPackaged(out int pfIsPackaged)
        {
            return this.innerProjectCfg2.get_IsPackaged(out pfIsPackaged);
        }

        public int get_IsPrivate(out int pfPrivate)
        {
            return this.innerProjectCfg2.get_IsPrivate(out pfPrivate);
        }

        public int get_IsReleaseOnly(out int pfIsReleaseOnly)
        {
            return this.get_IsReleaseOnly(out pfIsReleaseOnly);
        }

        public int get_IsSpecifyingOutputSupported(out int pfIsSpecifyingOutputSupported)
        {
            return this.innerProjectCfg2.get_IsSpecifyingOutputSupported(out pfIsSpecifyingOutputSupported);
        }

        public int get_OutputGroups(uint celt, IVsOutputGroup[] rgpcfg, uint[] pcActual)
        {
            return this.innerProjectCfg2.get_OutputGroups(celt, rgpcfg, pcActual);
        }

        public int get_Platform(out Guid pguidPlatform)
        {
            return this.innerProjectCfg2.get_Platform(out pguidPlatform);
        }

        public int get_ProjectCfgProvider(out IVsProjectCfgProvider ppIVsProjectCfgProvider)
        {
            ppIVsProjectCfgProvider = this.cfgProvider;
            return 0;
        }

        public int get_RootURL(out string pbstrRootURL)
        {
            return this.innerProjectCfg2.get_RootURL(out pbstrRootURL);
        }

        public int get_TargetCodePage(out uint puiTargetCodePage)
        {
            return this.innerProjectCfg2.get_TargetCodePage(out puiTargetCodePage);
        }

        public int get_UpdateSequenceNumber(ULARGE_INTEGER[] puliUSN)
        {
            return this.innerProjectCfg2.get_UpdateSequenceNumber(puliUSN);
        }

        public int get_VirtualRoot(out string pbstrVRoot)
        {
            return this.innerProjectCfg2.get_VirtualRoot(out pbstrVRoot);
        }

        public int OpenOutput(string szOutputCanonicalName, out IVsOutput ppIVsOutput)
        {
            return this.innerProjectCfg2.OpenOutput(szOutputCanonicalName, out ppIVsOutput);
        }

        public int OpenOutputGroup(string szCanonicalName, out IVsOutputGroup ppIVsOutputGroup)
        {
            return this.innerProjectCfg2.OpenOutputGroup(szCanonicalName, out ppIVsOutputGroup);
        }

        public int OutputsRequireAppRoot(out int pfRequiresAppRoot)
        {
            return this.innerProjectCfg2.OutputsRequireAppRoot(out pfRequiresAppRoot);
        }
    }
}

