﻿namespace Microsoft.Xna.GameStudio.ContentProject
{
    using Microsoft.VisualStudio;
    using Microsoft.VisualStudio.Shell.Interop;
    using System;
    using System.Runtime.InteropServices;

    internal class ProjectCfgProvider : IVsProjectCfgProvider, IVsCfgProvider
    {
        private IVsProjectCfgProvider innerProvider;

        public ProjectCfgProvider(IVsProjectCfgProvider innerProvider)
        {
            if (innerProvider == null)
            {
                throw new ArgumentNullException("innerProvider");
            }
            this.innerProvider = innerProvider;
        }

        public int get_UsesIndependentConfigurations(out int pfUsesIndependentConfigurations)
        {
            return this.innerProvider.get_UsesIndependentConfigurations(out pfUsesIndependentConfigurations);
        }

        public int GetCfgs(uint celt, IVsCfg[] rgpcfg, uint[] pcActual, uint[] prgfFlags)
        {
            int hr = this.innerProvider.GetCfgs(celt, rgpcfg, pcActual, prgfFlags);
            if (ErrorHandler.Succeeded(hr) && (rgpcfg != null))
            {
                for (int i = 0; i < rgpcfg.Length; i++)
                {
                    IVsProjectCfg2 cfg = rgpcfg[i] as IVsProjectCfg2;
                    if (cfg != null)
                    {
                        rgpcfg[i] = new ProjectCfg(cfg, this);
                    }
                }
            }
            return hr;
        }

        public int OpenProjectCfg(string szProjectCfgCanonicalName, out IVsProjectCfg ppIVsProjectCfg)
        {
            int num = this.innerProvider.OpenProjectCfg(szProjectCfgCanonicalName, out ppIVsProjectCfg);
            IVsProjectCfg2 cfg = ppIVsProjectCfg as IVsProjectCfg2;
            if (cfg != null)
            {
                ppIVsProjectCfg = new ProjectCfg(cfg, this);
            }
            return num;
        }
    }
}

