﻿namespace Microsoft.Xna.GameStudio.ContentProject
{
    using System;
    using System.Collections.ObjectModel;
    using System.ComponentModel;

    internal class StandardValuesExclusiveConverter : StringConverter
    {
        private ReadOnlyCollection<string> allowedValues;

        internal StandardValuesExclusiveConverter(ReadOnlyCollection<string> allowedValues)
        {
            if (allowedValues == null)
            {
                throw new ArgumentNullException("allowedValues");
            }
            this.allowedValues = allowedValues;
        }

        public override TypeConverter.StandardValuesCollection GetStandardValues(ITypeDescriptorContext context)
        {
            return new TypeConverter.StandardValuesCollection(this.allowedValues);
        }

        public override bool GetStandardValuesExclusive(ITypeDescriptorContext context)
        {
            return true;
        }

        public override bool GetStandardValuesSupported(ITypeDescriptorContext context)
        {
            return true;
        }
    }
}

