﻿namespace Microsoft.Xna.GameStudio
{
    using EnvDTE;
    using System;

    public abstract class InternalExtenderProvider<T> : INamedExtenderProvider, IExtenderProvider where T: AutomationExtender
    {
        protected InternalExtenderProvider()
        {
        }

        public virtual bool CanExtend(string ExtenderCATID, string ExtenderName, object ExtendeeObject)
        {
            return false;
        }

        protected abstract T CreateExtender(string ExtenderCATID, string ExtenderName, object ExtendeeObject, IExtenderSite ExtenderSite, int Cookie);
        public object GetExtender(string ExtenderCATID, string ExtenderName, object ExtendeeObject, IExtenderSite ExtenderSite, int Cookie)
        {
            T local = default(T);
            if (this.CanExtend(ExtenderCATID, ExtenderName, ExtendeeObject))
            {
                local = this.CreateExtender(ExtenderCATID, ExtenderName, ExtendeeObject, ExtenderSite, Cookie);
            }
            return local;
        }

        public string Name
        {
            get
            {
                return typeof(T).FullName;
            }
        }
    }
}

