﻿namespace Microsoft.Xna.GameStudio
{
    using System;

    internal static class ProjectConstants
    {
        internal const string BuildPageGuidString = "{A54AD834-9219-4AA6-B589-607AF21C3E26}";
        internal const string CancelEventNameFormat = @"Local\Microsoft.Xna.GameStudio.ContentPipeline.CancelBuildEvent+{0}";
        internal const int CLASS_E_NOAGGREGATION = -2147221232;
        internal static readonly Guid CLSID_BuildEventsPropertyPage = new Guid("1E78F8DB-6C07-4D61-A18F-7514010ABD56");
        internal static readonly Guid CLSID_ReferencesPathPropertyPage = new Guid("031911C8-6148-4E25-B1B1-44BCA9A0C45C");
        internal const int COR_E_EXCEPTION = -2146233088;
        internal const string CSharpApplicationPropPageGuidString = "{5E9A8AC2-4F34-4521-858F-4C248BA31532}";
        internal const string DebugPageGuidString = "{6185191F-1008-4FB2-A715-3A4E4F27E610}";
        internal const int E_MISSINGPROPERTY = -2147170504;
        internal const int E_RETRY_ADDCONTENTPROJ = -2147217072;
        private const int FACILITY_ITF = 4;
        public const string GameStudioVSPackageGuid = "4098508B-4144-45D3-9801-736DC39D8E8A";
        internal static readonly Guid GameStudioWindowPane = new Guid("354763DA-977D-4786-A703-2023725C70F6");
        internal const string MSBuildNamespace = "http://schemas.microsoft.com/developer/msbuild/2003";
        internal const string ProcessorParameterMetadataPrefix = "ProcessorParameters_";
        internal const string PublishingPageGuidString = "{CC4014F5-B18D-439C-9352-F99D984CCA85}";
        internal const string SecurityPageGuidString = "{DF8F7042-0BB1-47D1-8E6D-DEB3D07698BD}";
        internal const string ServicesPageGuidString = "{43E38D2E-43B8-4204-8225-9357316137A4}";
        internal static string[] SupportedSyncedProperties = new string[] { "CustomTool", "CustomToolNamespace", "ItemType", "CopyToOutputDirectory" };
        internal const uint VSHPROPID_IsXnaContentProject = 0xc474783f;
        internal const string XnaFramework31ProjectTypeGuids = "{6D335F3A-9D43-41b4-9D22-F6F17C4BE596};{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}";
        internal const string XnaFrameworkPublicKeyToken = "842cf8be1de50553";
        internal const string XnaPublicKeyToken = "6d5c3888ef60e27d";

        internal static class AutomationProperties
        {
            internal const string AllowUnsafeBlocks = "AllowUnsafeBlocks";
            internal const string AssemblyFileVersion = "AssemblyFileVersion";
            internal const string ComVisible = "ComVisible";
            internal const string EnableASPDebugging = "EnableASPDebugging";
            internal const string EnableASPXDebugging = "EnableASPXDebugging";
            internal const string EnableSecurityDebugging = "EnableSecurityDebugging";
            internal const string EnableSQLServerDebugging = "EnableSQLServerDebugging";
            internal const string EnableUnmanagedDebugging = "EnableUnmanagedDebugging";
            internal const string GameStartupType = "GameStartupType";
            internal const string NoStdLib = "NoStdLib";
            internal const string OutputType = "OutputType";
            internal const string PlatformTarget = "PlatformTarget";
            internal const string RegisterForComInterop = "RegisterForComInterop";
            internal const string RemoteDebugEnabled = "RemoteDebugEnabled";
            internal const string RemoteDebugMachine = "RemoteDebugMachine";
            internal const string SignManifests = "SignManifests";
            internal const string StartAction = "StartAction";
            internal const string StartupObject = "StartupObject";
            internal const string StartWorkingDirectory = "StartWorkingDirectory";
            internal const string TargetFrameworkMoniker = "TargetFrameworkMoniker";
            internal const string Thumbnail = "Thumbnail";
            internal const string TileImage = "TileImage";
            internal const string TileTitle = "TileTitle";
            internal const string UseVSHostingProcess = "UseVSHostingProcess";
            internal const string XnaProfile = "XnaProfile";
        }

        internal static class BootstrapperPackages
        {
            internal const string v30 = "Microsoft.Xna.Framework.3.0";
            internal const string v31 = "Microsoft.Xna.Framework.3.1";
            internal const string v40 = "Microsoft.Xna.Framework.4.0";
        }

        internal static class BuildItemGroups
        {
            internal const string COMFileReference = "COMFileReference";
            internal const string COMReference = "COMReference";
            internal const string NestedContentProject = "NestedContentProject";
            internal const string ProjectReference = "ProjectReference";
            internal const string Reference = "Reference";
            internal const string WCFServiceReference = "WCFMetadata";
            internal const string WCFServiceReferenceStorage = "WCFMetadataStorage";
            internal const string WebReferenceUrl = "WebReferenceUrl";
        }

        internal static class BuildProperties
        {
            internal const string AssemblyName = "AssemblyName";
            internal const string Configuration = "Configuration";
            internal const string ContentRootDirectory = "ContentRootDirectory";
            internal const string DefineConstants = "DefineConstants";
            internal const string GameStartupType = "GameStartupType";
            internal const string NestedContentProject = "_NestedContentProject";
            internal const string OutputType = "OutputType";
            internal const string Platform = "Platform";
            internal const string ProjectGuid = "ProjectGuid";
            internal const string ProjectTypeGuids = "ProjectTypeGuids";
            internal const string SilverlightManifestTemplate = "SilverlightManifestTemplate";
            internal const string StartupObject = "StartupObject";
            internal const string TargetFrameworkProfile = "TargetFrameworkProfile";
            internal const string TargetFrameworkVersion = "TargetFrameworkVersion";
            internal const string Thumbnail = "Thumbnail";
            internal const string TileImage = "TileImage";
            internal const string TileTitle = "TileTitle";
            internal const string WPTombstoneEnabled = "WPTombstoneEnabled";
            internal const string XnaCompressContent = "XnaCompressContent";
            internal const string XnaCrossPlatformGroupID = "XnaCrossPlatformGroupID";
            internal const string XnaFrameworkRuntimeProfile = "XnaFrameworkRuntimeProfile";
            internal const string XnaFrameworkVersion = "XnaFrameworkVersion";
            internal const string XnaOutputType = "XnaOutputType";
            internal const string XnaPlatform = "XnaPlatform";
            internal const string XnaProfile = "XnaProfile";
            internal const string XnaRefreshLevel = "XnaRefreshLevel";
            internal const string XnaUpgrade = "XnaUpgrade";
            internal const string XnaWindowsPhoneManifestTemplate = "XnaWindowsPhoneManifestTemplate";
        }

        internal static class ConfigFileMetadata
        {
            internal const string XnaPlatformSpecific = "XnaPlatformSpecific";
        }

        internal static class GraphicsProfiles
        {
            internal const string HiDefProfile = "HiDef";
            internal const string ReachProfile = "Reach";
        }

        internal static class HelpContextFilters
        {
            internal const string ContentProject = "XNA Content Project";
            internal const string MobileProject = "XNA Platform Windows Phone";
            internal const string Product = "XNA";
            internal const string WindowsProject = "XNA Platform Windows";
            internal const string Xbox360Project = "XNA Platform Xbox 360";

            internal static class ProjType
            {
                internal const string v40 = "XNA_40";
            }
        }

        internal static class LanguageAdapterCaps
        {
            internal const string DefaultAppSettings = "defaultAppSettings";
        }

        internal static class NestedContentProjectMetadata
        {
            internal const string InstanceGuid = "Project";
            internal const string Visibility = "Visible";
        }

        internal static class ProjectPlatformAdapterCaps
        {
            internal const string BootstrapperClickOnce = "bootstrapperClickOnce";
            internal const string CentralDeviceSelector = "centralDeviceSelector";
            internal const string DefaultDeviceList = "listDefaultDevice";
            internal const string TombstoneDebugging = "tombstoneDebugging";
        }

        internal static class ProjectReferenceMetadata
        {
            internal const string ContentReferenceType = "Content";
            internal const string XnaReferenceType = "XnaReferenceType";
        }

        internal static class ReferenceMetadata
        {
            internal const string PrivateAttributeName = "Private";
            internal const string RequiredTargetFrameworkAttributeName = "RequiredTargetFramework";
        }

        internal static class RefreshLevels
        {
            internal const string RefreshLevelOne = "1";
            internal const string RefreshLevelZero = "0";
        }

        internal static class SilverlightShared
        {
            internal const string SdkInstallPathRegKey = @"SOFTWARE\Microsoft\Microsoft SDKs\WindowsPhone\v7.0\Install Path";
            internal const string ServiceReferenceConfigFileName = "ServiceReferences.ClientConfig";
            internal const string ServiceReferenceInstallPathName = "Install Path";
            internal const string ServiceReferenceSubPath = @"Tools\Microsoft.Silverlight.Phone.ServiceReference.dll";
            internal const string SilverlightProjectGuid = "{A1591282-1198-4647-A2B1-27E5FF5F6F3B}";
        }

        internal static class StandardSubVSSKUs
        {
            internal const int SubSKUEdition_Architect = 8;
            internal const int SubSKUEdition_CSharp = 4;
            internal const int SubSKUEdition_IDE = 0x10;
            internal const int SubSKUEdition_JSharp = 0x20;
            internal const int SubSKUEdition_None = 0;
            internal const int SubSKUEdition_TeamEditionDevelopers = 0x80;
            internal const int SubSKUEdition_VB = 2;
            internal const int SubSKUEdition_VC = 1;
            internal const int SubSKUEdition_Web = 0x40;
            internal const int SubSKUEdition_WPDT = 0x1000;
        }

        internal static class StandardVSSKUs
        {
            internal const int SKUEdition_AcademicEnterprise = 0x8fc;
            internal const int SKUEdition_AcademicProfessional = 0x834;
            internal const int SKUEdition_AcademicStudent = 0x834;
            internal const int SKUEdition_AcademicStudentMSDNAA = 0x898;
            internal const int SKUEdition_Book = 0x960;
            internal const int SKUEdition_DownloadTrial = 0x9c4;
            internal const int SKUEdition_Enterprise = 0xbb8;
            internal const int SKUEdition_Express = 500;
            internal const int SKUEdition_None = 0;
            internal const int SKUEdition_Professional = 0x7d0;
            internal const int SKUEdition_Standard = 0x3e8;
        }

        internal static class UserProjectProperties
        {
            internal const string SelectedDeployDevice = "XNASelectedDeployDevice";
        }

        internal static class VsTemplate
        {
            internal const string CopyFileElement = "CopyFile";
            internal const string CopyFileTargetFolderNameAttribute = "TargetFolderName";
            internal const string DefaultSolutionPlatformElement = "DefaultSolutionPlatform";
            internal const string GameThumbnailReplacementKey = "GameThumbnail.png";
            internal const string Guid1ReplacementKey = "$guid1$";
            internal const string PreservePropertyAttributeName = "Preserve";
            internal const string SafeProjectNameReplacementKey = "$safeprojectname$";
            internal const string WizardDataReplacementKey = "$wizarddata$";

            internal static class Folder
            {
                internal const string ElementName = "Folder";
                internal const string Name = "Name";
                internal const string TargetFolderName = "TargetFolderName";
            }

            internal static class ProjectItem
            {
                internal const string AddToSolution = "AddToSolution";
                internal const string ElementName = "ProjectItem";
                internal const string ReplaceParameters = "ReplaceParameters";
                internal const string TargetFileName = "TargetFileName";
            }
        }

        internal static class XnaFrameworks
        {
            internal const string XnaFramework10 = "v1.0";
            internal const string XnaFramework20 = "v2.0";
            internal const string XnaFramework30 = "v3.0";
            internal const string XnaFramework31 = "v3.1";
            internal const string XnaFramework40 = "v4.0";
        }

        internal static class XnaPlatforms
        {
            internal const string WindowsPhonePlatform = "Windows Phone";
            internal const string WindowsPlatform = "Windows";
            internal const string Xbox360Platform = "Xbox 360";
            internal const string ZunePlatform = "Zune";
        }
    }
}

