﻿namespace Microsoft.Xna.GameStudio
{
    using Microsoft.VisualStudio;
    using Microsoft.VisualStudio.Shell.Interop;
    using System;
    using System.Drawing;
    using System.Windows.Forms;

    internal class ProjectHierarchyItem : HierarchyItem, IDisposable
    {
        private ImageList projectImageList;

        internal ProjectHierarchyItem(IVsUIHierarchy innerIVsUIHierarchy) : base(innerIVsUIHierarchy)
        {
            base.OverrideProperty(-2095, false);
            base.OverrideProperty(-2094, false);
        }

        protected int AddImageListIcon(Image image)
        {
            if (image == null)
            {
                throw new ArgumentNullException("image");
            }
            ImageList iconImageList = this.IconImageList;
            int count = iconImageList.Images.Count;
            iconImageList.Images.Add(image, Color.Magenta);
            return count;
        }

        public void Dispose()
        {
            this.Dispose(true);
            GC.SuppressFinalize(this);
        }

        protected virtual void Dispose(bool disposing)
        {
            if (disposing && (this.projectImageList != null))
            {
                this.projectImageList.Dispose();
                this.projectImageList = null;
            }
        }

        ~ProjectHierarchyItem()
        {
            this.Dispose(false);
        }

        protected ImageList IconImageList
        {
            get
            {
                if (this.projectImageList == null)
                {
                    object pvar = null;
                    ErrorHandler.ThrowOnFailure(base.InnerHierarchy.GetProperty(0xfffffffe, -2004, out pvar));
                    this.projectImageList = Microsoft.Xna.GameStudio.ProjectUtilities.GetImageList(pvar);
                }
                return this.projectImageList;
            }
        }
    }
}

