﻿namespace Microsoft.Xna.GameStudio.Projects.LanguageAdapters
{
    using Microsoft.Xna.GameStudio;
    using System;
    using System.Collections.Generic;
    using System.Linq;

    internal class VisualBasicPropertyPageHandler : BasePropertyPageHandler
    {
        private readonly string MyExtensionsPropertyPage = "{F24459FC-E883-4A8E-9DA2-AEF684F0E1F4}";
        private readonly string VBApplicationPropertyPage = "{8998E48E-B89A-4034-B66E-353D8C1FDC2E}";
        private readonly string VBCompilePropertyPage = "{EDA661EA-DC61-4750-B3A5-F6E9C74060F5}";
        private readonly string VBOutputType = "OutputType";
        private readonly string VBReferencesPropertyPage = "{4E43F4AB-9F03-4129-95BF-B8FF870AF6AB}";
        private readonly string VBXNAReferencePage = "{9C589350-094B-11E0-AB4F-6ACCDFD72085}";

        public override IEnumerable<string> FilterAndTranslateProperties(IEnumerable<string> properties)
        {
            return Enumerable.Select<string, string>(properties.ToList<string>(), new Func<string, string>(this, (IntPtr) this.<FilterAndTranslateProperties>b__3));
        }

        public override IEnumerable<string> FilterAndTranslatePropertyPages(IEnumerable<string> propertyPages)
        {
            return Enumerable.Select<string, string>(propertyPages.ToList<string>(), new Func<string, string>(this, (IntPtr) this.<FilterAndTranslatePropertyPages>b__1)).Union<string>(new string[] { this.MyExtensionsPropertyPage, this.VBReferencesPropertyPage });
        }

        private string ReplacePageName(string t)
        {
            if (string.Equals(t, "{5E9A8AC2-4F34-4521-858F-4C248BA31532}"))
            {
                return this.VBApplicationPropertyPage;
            }
            if (string.Equals(t, "{A54AD834-9219-4AA6-B589-607AF21C3E26}"))
            {
                return this.VBCompilePropertyPage;
            }
            if (string.Equals(t, Microsoft.Xna.GameStudio.ProjectConstants.CLSID_ReferencesPathPropertyPage.ToString("B")))
            {
                return this.VBReferencesPropertyPage;
            }
            return t;
        }

        private string ReplacePropertyName(string t)
        {
            if (string.Equals(t, "OutputType"))
            {
                return this.VBOutputType;
            }
            return t;
        }

        public override IEnumerable<string> TranslateProperties(IEnumerable<string> properties)
        {
            return Enumerable.Select<string, string>(properties.ToList<string>(), new Func<string, string>(this, (IntPtr) this.<TranslateProperties>b__2));
        }

        public override IEnumerable<string> TranslatePropertyPages(IEnumerable<string> propertyPages)
        {
            return Enumerable.Select<string, string>(propertyPages.ToList<string>(), new Func<string, string>(this, (IntPtr) this.<TranslatePropertyPages>b__0));
        }

        public override IEnumerable<string> NewCfgPropertyPages
        {
            get
            {
                return new string[] { this.VBXNAReferencePage };
            }
        }
    }
}

