﻿namespace Microsoft.Xna.GameStudio
{
    using Microsoft.VisualStudio;
    using Microsoft.VisualStudio.Shell;
    using Microsoft.VisualStudio.Shell.Interop;
    using Microsoft.Xna.GameStudio.Resources;
    using System;
    using System.Globalization;

    internal static class VsShellMessageBox
    {
        internal static Result Show(string title, string text, string f1Keyword, uint helpContextID, OLEMSGBUTTON msgbtn, OLEMSGDEFBUTTON msgdefbtn, OLEMSGICON msgicon)
        {
            if (text == null)
            {
                throw new ArgumentNullException("text");
            }
            IVsUIShell globalService = Package.GetGlobalService(typeof(SVsUIShell)) as IVsUIShell;
            if (globalService == null)
            {
                throw new InvalidOperationException(string.Format(CultureInfo.InvariantCulture, XnaProjectResource.MissingService, new object[] { typeof(SVsUIShell).FullName }));
            }
            Guid empty = Guid.Empty;
            int pnResult = 0;
            ErrorHandler.ThrowOnFailure(globalService.ShowMessageBox(0, ref empty, title, text, f1Keyword, helpContextID, msgbtn, msgdefbtn, msgicon, 0, out pnResult));
            return (Result) pnResult;
        }

        internal enum Result
        {
            None,
            OK,
            Cancel,
            Abort,
            Retry,
            Ignore,
            Yes,
            No,
            Close,
            Help,
            TryAgain,
            Continue
        }
    }
}

