﻿namespace Microsoft.Xna.GameStudio.WindowsPhone
{
    using Microsoft.VisualStudio.Shell.Interop;
    using Microsoft.Xna.GameStudio;
    using Microsoft.Xna.GameStudio.CodeProject;
    using Microsoft.Xna.GameStudio.CodeProject.Debugging;
    using System;
    using System.Runtime.InteropServices;

    internal class WindowsPhoneDebuggableProjectCfg : DebuggableProjectCfg
    {
        internal WindowsPhoneDebuggableProjectCfg(PlatformFlavorCfg parentCfg) : base(parentCfg)
        {
        }

        protected override void GetDebugTargetInfo(ref VsDebugTargetInfo2 debugTarget, uint grfLaunch, Guid titleId, string args)
        {
            debugTarget.cbSize = (uint) Marshal.SizeOf((VsDebugTargetInfo2) debugTarget);
            debugTarget.dlo = 2;
            debugTarget.LaunchFlags = grfLaunch;
            debugTarget.bstrExe = @"\Windows\taskhost.exe";
            debugTarget.bstrCurDir = @"\";
            DebuggableProjectCfg.SetDebugEngine(ref debugTarget, ProjectSystemConstants.DebuggerGuid);
            debugTarget.guidPortSupplier = ProjectSystemConstants.PortSupplierGuid;
            string buildProperty = base.parentCfg.Project.GetBuildProperty("WPTombstoneEnabled", null);
            if (!(base.parentCfg.Project.Adapter is IXnaRefreshLevel) || !string.Equals(base.parentCfg.Project.GetBuildProperty("XnaRefreshLevel", null), ((IXnaRefreshLevel) base.parentCfg.Project.Adapter).MaximumRefreshLevel()))
            {
                buildProperty = "false";
            }
            debugTarget.bstrArg = string.Format("{0}/_default; /threadId:0 /taskType:2 /forceTS:{1} /processId:0", titleId.ToString("B"), bool.TrueString.Equals(buildProperty, StringComparison.OrdinalIgnoreCase) ? "1" : "0");
            string targetConsole = base.parentCfg.TargetConsole;
            debugTarget.bstrPortName = string.Format("{0};{1}", "7E6B29E6-AAE1-41dc-9849-049507CBA2B0", targetConsole);
        }

        [StructLayout(LayoutKind.Sequential, Size=1)]
        public struct ProjectSystemConstants
        {
            public const string DeployDeviceId = "DeployDeviceId";
            public const string SlmHostExeCmdArg = @"file://\Program Files\";
            public const string SlmHostOnDevice = @"\Windows\taskhost.exe";
            public static readonly Guid DebuggerGuid;
            public static readonly Guid PortSupplierGuid;
            static ProjectSystemConstants()
            {
                DebuggerGuid = new Guid("{8C37B683-C921-4076-AC47-EC6DA03FA658}");
                PortSupplierGuid = new Guid("{2D32AA54-1F84-4964-BC13-ECB871943797}");
            }
        }
    }
}

