﻿namespace Microsoft.Xna.GameStudio
{
    using Microsoft.Xna.GameStudio.Resources;
    using System;
    using System.ComponentModel;
    using System.Globalization;

    [AttributeUsage(AttributeTargets.Field | AttributeTargets.Property | AttributeTargets.Class, Inherited=false, AllowMultiple=false)]
    internal sealed class XnaDisplayNameAttribute : DisplayNameAttribute
    {
        public XnaDisplayNameAttribute(string resourceIdentifier) : base(resourceIdentifier)
        {
            if (resourceIdentifier == null)
            {
                throw new ArgumentNullException("resourceIdentifier");
            }
        }

        public override string DisplayName
        {
            get
            {
                string str = XnaProjectResource.ResourceManager.GetString(base.DisplayNameValue);
                if (str == null)
                {
                    throw new InvalidOperationException(string.Format(CultureInfo.CurrentUICulture, XnaProjectResource.LocalizedResourceLookupFailed, new object[] { base.DisplayNameValue }));
                }
                return str;
            }
        }
    }
}

