﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using System;

    public sealed class HelpContextFilters
    {
        private string product;
        private string project;
        private string projType;

        public HelpContextFilters(string product, string projType, string project)
        {
            if (product == null)
            {
                throw new ArgumentNullException("product");
            }
            if (projType == null)
            {
                throw new ArgumentNullException("projType");
            }
            if (project == null)
            {
                throw new ArgumentNullException("project");
            }
            this.product = product;
            this.projType = projType;
            this.project = project;
        }

        public string Product
        {
            get
            {
                return this.product;
            }
        }

        public string Project
        {
            get
            {
                return this.project;
            }
        }

        public string ProjType
        {
            get
            {
                return this.projType;
            }
        }
    }
}

