﻿namespace Microsoft.Xna.GameStudio.CodeProject
{
    using Microsoft.Build.Construction;
    using Microsoft.VisualStudio.Shell.Interop;
    using System;
    using System.Collections.Generic;
    using System.Drawing;

    public interface IProjectPlatformAdapter
    {
        void AddPlatformSpecificComponents(ProjectRootElement projectRoot, List<string> errors);
        IVsProjectFlavorCfg CreateProjectFlavorCfg(IServiceProvider serviceProvider, IVsCfg baseProjectCfg, IVsProjectFlavorCfg innerFlavorCfg);
        IEnumerable<string> FilteredPropertyPages();
        string[] GetDeviceSdkPaths();
        string[] GetFilterProperties();
        object GetHierarchyObject(Type objectType);

        Guid AddItemTemplatesGuid { get; }

        IList<INamedExtenderProvider> ExtenderProviders { get; }

        string[] GetDisabledPropertyList { get; }

        Microsoft.Xna.GameStudio.CodeProject.HelpContextFilters HelpContextFilters { get; }

        bool IsDevicePlatform { get; }

        string NestedContentXnaPlatform { get; }

        string PlatformConfigurationName { get; }

        string PlatformConstants { get; }

        Bitmap ProjectNodeIcon { get; }

        Guid ProjectTypeGuid { get; }

        bool SupportsContentCompression { get; }

        bool SupportsCrossPlatform { get; }

        bool SupportsDeviceCenter { get; }

        bool SupportsPackaging { get; }

        bool SupportsServiceReferences { get; }

        string XnaFrameworkRuntimeProfile { get; }

        string XnaFrameworkVersion { get; }

        string XnaPlatform { get; }
    }
}

