﻿namespace Microsoft.Xna.GameStudio
{
    using Microsoft.Build.Construction;
    using Microsoft.VisualStudio.Shell.Interop;
    using Microsoft.Xna.GameStudio.CodeProject;
    using System;
    using System.Collections.Generic;
    using System.Runtime.InteropServices;

    public interface IProjectLanguageAdapter
    {
        string GetCapability(string capabilityName);
        Guid GetItemTemplatesGuid(Guid guid);
        List<string> GetLanguageCaps();
        IEnumerable<uint> GetReferenceNodes();
        uint GetReferencesFolderNode();
        IEnumerable<uint> GetVirtualFolders();
        void Initialize(IVsHierarchy innerHierarchy, IProjectPlatformAdapter adapter, IServiceProvider serviceProvider);
        void ModifyProjectOnCopy(ProjectRootElement projectRoot, IProjectPlatformAdapter targetAdapter);
        bool QueryService(ref Guid guidService, ref Guid riid, out object service);
        string TranslateProjectDefines(string defines);

        Guid LanguageGuid { get; }

        string Name { get; }

        string ProjectBrowseObjectGuidString { get; }

        string ProjectConfigBrowseObjectGuidString { get; }

        IPropertyPageProvider PropertyPageHandler { get; }
    }
}

