﻿namespace Microsoft.Xna.GameStudio.Wizards
{
    using Microsoft.Xna.GameStudio;
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.Runtime.CompilerServices;
    using System.Windows.Forms;

    public class Option : UserControl
    {
        private ComboBox comboBoxOptionList;
        private IContainer components;
        private Label labelDescription;
        private Label labelTitle;
        private Panel panelOption;
        private List<XnaProjectCreationOption.Selection> selectionList = new List<XnaProjectCreationOption.Selection>();

        public Option()
        {
            this.InitializeComponent();
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.panelOption = new Panel();
            this.labelDescription = new Label();
            this.labelTitle = new Label();
            this.comboBoxOptionList = new ComboBox();
            this.panelOption.SuspendLayout();
            base.SuspendLayout();
            this.panelOption.AutoSize = true;
            this.panelOption.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            this.panelOption.Controls.Add(this.labelDescription);
            this.panelOption.Controls.Add(this.labelTitle);
            this.panelOption.Controls.Add(this.comboBoxOptionList);
            this.panelOption.Location = new Point(3, 3);
            this.panelOption.Name = "panelOption";
            this.panelOption.Size = new Size(0x100, 0x63);
            this.panelOption.TabIndex = 3;
            this.labelDescription.AutoSize = true;
            this.labelDescription.Location = new Point(3, 8);
            this.labelDescription.Margin = new Padding(3);
            this.labelDescription.Name = "labelDescription";
            this.labelDescription.Size = new Size(60, 13);
            this.labelDescription.TabIndex = 0;
            this.labelDescription.Text = "Description";
            this.labelTitle.AutoSize = true;
            this.labelTitle.Location = new Point(3, 0x30);
            this.labelTitle.Name = "labelTitle";
            this.labelTitle.Size = new Size(0x1b, 13);
            this.labelTitle.TabIndex = 1;
            this.labelTitle.Text = "Title";
            this.comboBoxOptionList.Location = new Point(3, 0x4b);
            this.comboBoxOptionList.Name = "comboBoxOptionList";
            this.comboBoxOptionList.Size = new Size(250, 0x15);
            this.comboBoxOptionList.DropDownStyle = ComboBoxStyle.DropDownList;
            this.comboBoxOptionList.TabIndex = 2;
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.AutoSize = true;
            base.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            base.Controls.Add(this.panelOption);
            base.Name = "Option";
            base.Size = new Size(0x106, 0x69);
            this.panelOption.ResumeLayout(false);
            this.panelOption.PerformLayout();
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        public string Description
        {
            get
            {
                return this.labelDescription.Text;
            }
            set
            {
                this.labelDescription.Text = value;
            }
        }

        public string PropertyName { get; set; }

        public XnaProjectCreationOption.Selection Selected
        {
            get
            {
                if (this.selectionList.Count == 1)
                {
                    return this.selectionList[0];
                }
                if ((this.comboBoxOptionList.SelectedItem != null) && (this.comboBoxOptionList.SelectedItem is XnaProjectCreationOption.Selection))
                {
                    return (this.comboBoxOptionList.SelectedItem as XnaProjectCreationOption.Selection);
                }
                return null;
            }
        }

        public List<XnaProjectCreationOption.Selection> SelectionList
        {
            get
            {
                return new List<XnaProjectCreationOption.Selection>(this.selectionList);
            }
            set
            {
                this.selectionList = new List<XnaProjectCreationOption.Selection>(value);
                XnaProjectCreationOption.Selection selection = null;
                this.comboBoxOptionList.Items.Clear();
                foreach (XnaProjectCreationOption.Selection selection2 in this.selectionList)
                {
                    this.comboBoxOptionList.Items.Add(selection2);
                    if (selection2.IsDefault && (selection == null))
                    {
                        selection = selection2;
                    }
                }
                if (selection != null)
                {
                    this.comboBoxOptionList.SelectedItem = selection;
                }
            }
        }

        public string Title
        {
            get
            {
                return this.labelTitle.Text;
            }
            set
            {
                this.labelTitle.Text = value;
            }
        }
    }
}

