﻿namespace Microsoft.Xna.GameStudio
{
    using System;
    using System.Collections.Generic;
    using System.Runtime.CompilerServices;
    using System.Runtime.InteropServices;

    public sealed class XnaProjectCreationOption
    {
        public XnaProjectCreationOption()
        {
            if (this.Selections == null)
            {
                this.Selections = new List<Selection>();
            }
        }

        public XnaProjectCreationOption(string title = "", string property = "", string description = "", List<Selection> selections = null)
        {
            this.Title = title;
            this.Property = property;
            this.Description = description;
            this.Selections = selections;
            if (this.Selections == null)
            {
                this.Selections = new List<Selection>();
            }
        }

        public string Description { get; set; }

        public string Property { get; set; }

        public List<Selection> Selections { get; set; }

        public string Title { get; set; }

        public sealed class Selection
        {
            public Selection(string name = "", string value = "", string description = "", bool isDefault = false)
            {
                this.Name = name;
                this.Value = value;
                this.Description = description;
                this.IsDefault = isDefault;
            }

            public override string ToString()
            {
                return this.Name;
            }

            public string Description { get; set; }

            public bool IsDefault { get; set; }

            public string Name { get; set; }

            public string Value { get; set; }
        }
    }
}

