#pragma once

using namespace System;

namespace Microsoft {
	namespace Xna {
		namespace Framework {
			namespace Graphics {
				namespace PackedVector {

					generic<typename T>
					public ref struct Alpha8 : IPackedVector<byte>, IPackedVector, IEquatable<Alpha8>
					{
						private byte packedValue;
						public Alpha8(float alpha);
						void IPackedVector.PackFromVector4(Vector4 vector);
						private static byte PackHelper(float alpha);
						public float ToAlpha();
						Vector4 IPackedVector.ToVector4();
						public byte PackedValue { get; set; }
						public override string ToString();
						public override int GetHashCode();
						public override bool Equals(object obj);
						public bool Equals(Alpha8 other);
						public static bool operator ==(Alpha8 a, Alpha8 b);
						public static bool operator !=(Alpha8 a, Alpha8 b);
					}
				}
			}
		}
	}
}
