#include "stdafx.h"

using namespace System::Globalization;

#include "Vector2.h"

namespace Microsoft {
	namespace Xna {
		namespace Framework {
			Vector2::Vector2(float x, float y)
			{
				this->X = x;
				this->Y = y;
			}

			Vector2::Vector2(float value)
			{
				this->X = this->Y = value;
			}

			String^ Vector2::ToString()
			{
				CultureInfo ^currentCulture = CultureInfo::CurrentCulture;
				//return String::Format(currentCulture, "{{X:{0} Y:{1}}}", gcnew array<Object^> { this->X->ToString(currentCulture), this->Y->ToString(currentCulture) });
				return L"";
			}

			bool Vector2::Equals(Vector2 ^other)
			{
				return ((this->X == other->X) && (this->Y == other->Y));
			}

			bool Vector2::Equals(Object ^obj)
			{
				bool flag = false;
				/*if (obj is Vector2)
				{
					flag = this->Equals((Vector2) obj);
				}*/
				return flag;
			}

			int Vector2::GetHashCode()
			{
				//return (this->X->GetHashCode() + this->Y->GetHashCode());
				return 1;
			}

			float Vector2::Length()
			{
				float num = (this->X * this->X) + (this->Y * this->Y);
				return (float) Math::Sqrt((double) num);
			}

			float Vector2::LengthSquared()
			{
				return ((this->X * this->X) + (this->Y * this->Y));
			}

			float Vector2::Distance(Vector2 ^value1, Vector2 ^value2)
			{
				float num2 = value1->X - value2->X;
				float num = value1->Y - value2->Y;
				float num3 = (num2 * num2) + (num * num);
				return (float) Math::Sqrt((double) num3);
			}

			void Vector2::Distance(Vector2 ^%value1, Vector2 ^%value2, [Out] float ^%result)
			{
				float num2 = value1->X - value2->X;
				float num = value1->Y - value2->Y;
				float num3 = (num2 * num2) + (num * num);
				result = (float) Math::Sqrt((double) num3);
			}

			float Vector2::DistanceSquared(Vector2 ^value1, Vector2 ^value2)
			{
				float num2 = value1->X - value2->X;
				float num = value1->Y - value2->Y;
				return ((num2 * num2) + (num * num));
			}

			void Vector2::DistanceSquared(Vector2 ^%value1, Vector2 ^%value2, [Out] float ^%result)
			{
				float num2 = value1->X - value2->X;
				float num = value1->Y - value2->Y;
				result = (num2 * num2) + (num * num);
			}

			float Vector2::Dot(Vector2 ^value1, Vector2 ^value2)
			{
				return ((value1->X * value2->X) + (value1->Y * value2->Y));
			}

			void Vector2::Dot(Vector2 ^%value1, Vector2 ^%value2, [Out] float ^%result)
			{
				result = (value1->X * value2->X) + (value1->Y * value2->Y);
			}

			void Vector2::Normalize()
			{
				float num2 = (this->X * this->X) + (this->Y * this->Y);
				float num = 1.0f / ((float) Math::Sqrt((double) num2));
				this->X *= num;
				this->Y *= num;
			}

			Vector2^ Vector2::Normalize(Vector2 ^value)
			{
				Vector2 ^vector;
				float num2 = (value->X * value->X) + (value->Y * value->Y);
				float num = 1.0f / ((float) Math::Sqrt((double) num2));
				vector->X = value->X * num;
				vector->Y = value->Y * num;
				return vector;
			}

			void Vector2::Normalize(Vector2 ^%value, [Out] Vector2 ^%result)
			{
				float num2 = (value->X * value->X) + (value->Y * value->Y);
				float num = 1.0f / ((float) Math::Sqrt((double) num2));
				result->X = value->X * num;
				result->Y = value->Y * num;
			}

			Vector2^ Vector2::Reflect(Vector2 ^vector, Vector2 ^normal)
			{
				Vector2 ^vector2;
				float num = (vector->X * normal->X) + (vector->Y * normal->Y);
				vector2->X = vector->X - ((2.0f * num) * normal->X);
				vector2->Y = vector->Y - ((2.0f * num) * normal->Y);
				return vector2;
			}

			void Vector2::Reflect(Vector2 ^%vector, Vector2 ^%normal, [Out] Vector2 ^%result)
			{
				float num = (vector->X * normal->X) + (vector->Y * normal->Y);
				result->X = vector->X - ((2.0f * num) * normal->X);
				result->Y = vector->Y - ((2.0f * num) * normal->Y);
			}

			Vector2^ Vector2::Min(Vector2 ^value1, Vector2 ^value2)
			{
				Vector2 ^vector;
				vector->X = (value1->X < value2->X) ? value1->X : value2->X;
				vector->Y = (value1->Y < value2->Y) ? value1->Y : value2->Y;
				return vector;
			}

			void Vector2::Min(Vector2 ^%value1, Vector2 ^%value2, [Out] Vector2 ^%result)
			{
				result->X = (value1->X < value2->X) ? value1->X : value2->X;
				result->Y = (value1->Y < value2->Y) ? value1->Y : value2->Y;
			}

			Vector2^ Vector2::Max(Vector2 ^value1, Vector2 ^value2)
			{
				Vector2 ^vector;
				vector->X = (value1->X > value2->X) ? value1->X : value2->X;
				vector->Y = (value1->Y > value2->Y) ? value1->Y : value2->Y;
				return vector;
			}

			void Vector2::Max(Vector2 ^%value1, Vector2 ^%value2, [Out] Vector2 ^%result)
			{
				result->X = (value1->X > value2->X) ? value1->X : value2->X;
				result->Y = (value1->Y > value2->Y) ? value1->Y : value2->Y;
			}

			Vector2^ Vector2::Clamp(Vector2 ^value1, Vector2 ^min, Vector2 ^max)
			{
				Vector2 ^vector;
				float x = value1->X;
				x = (x > max->X) ? max->X : x;
				x = (x < min->X) ? min->X : x;
				float y = value1->Y;
				y = (y > max->Y) ? max->Y : y;
				y = (y < min->Y) ? min->Y : y;
				vector->X = x;
				vector->Y = y;
				return vector;
			}

			void Vector2::Clamp(Vector2 ^%value1, Vector2 ^%min, Vector2 ^%max, [Out] Vector2 ^%result)
			{
				float x = value1->X;
				x = (x > max->X) ? max->X : x;
				x = (x < min->X) ? min->X : x;
				float y = value1->Y;
				y = (y > max->Y) ? max->Y : y;
				y = (y < min->Y) ? min->Y : y;
				result->X = x;
				result->Y = y;
			}

			Vector2^ Vector2::Lerp(Vector2 ^value1, Vector2 ^value2, float amount)
			{
				Vector2 ^vector;
				vector->X = value1->X + ((value2->X - value1->X) * amount);
				vector->Y = value1->Y + ((value2->Y - value1->Y) * amount);
				return vector;
			}

			void Vector2::Lerp(Vector2 ^%value1, Vector2 ^%value2, float amount, [Out] Vector2 ^%result)
			{
				result->X = value1->X + ((value2->X - value1->X) * amount);
				result->Y = value1->Y + ((value2->Y - value1->Y) * amount);
			}

			Vector2^ Vector2::Barycentric(Vector2 ^value1, Vector2 ^value2, Vector2 ^value3, float amount1, float amount2)
			{
				Vector2 ^vector;
				vector->X = (value1->X + (amount1 * (value2->X - value1->X))) + (amount2 * (value3->X - value1->X));
				vector->Y = (value1->Y + (amount1 * (value2->Y - value1->Y))) + (amount2 * (value3->Y - value1->Y));
				return vector;
			}

			void Vector2::Barycentric(Vector2 ^%value1, Vector2 ^%value2, Vector2 ^%value3, float amount1, float amount2, [Out] Vector2 ^%result)
			{
				result->X = (value1->X + (amount1 * (value2->X - value1->X))) + (amount2 * (value3->X - value1->X));
				result->Y = (value1->Y + (amount1 * (value2->Y - value1->Y))) + (amount2 * (value3->Y - value1->Y));
			}

			Vector2^ Vector2::SmoothStep(Vector2 ^value1, Vector2 ^value2, float amount)
			{
				Vector2 ^vector;
				amount = (amount > 1.0f) ? 1.0f : ((amount < 0.0f) ? 0.0f : amount);
				amount = (amount * amount) * (3.0f - (2.0f * amount));
				vector->X = value1->X + ((value2->X - value1->X) * amount);
				vector->Y = value1->Y + ((value2->Y - value1->Y) * amount);
				return vector;
			}

			void Vector2::SmoothStep(Vector2 ^%value1, Vector2 ^%value2, float amount, [Out] Vector2 ^%result)
			{
				amount = (amount > 1.0f) ? 1.0f : ((amount < 0.0f) ? 0.0f : amount);
				amount = (amount * amount) * (3.0f - (2.0f * amount));
				result->X = value1->X + ((value2->X - value1->X) * amount);
				result->Y = value1->Y + ((value2->Y - value1->Y) * amount);
			}

			Vector2^ Vector2::CatmullRom(Vector2 ^value1, Vector2 ^value2, Vector2 ^value3, Vector2 ^value4, float amount)
			{
				Vector2 ^vector;
				float num = amount * amount;
				float num2 = amount * num;
				vector->X = 0.5f * ((((2.0f * value2->X) + ((-value1->X + value3->X) * amount)) + (((((2.0f * value1->X) - (5.0f * value2->X)) + (4.0f * value3->X)) - value4->X) * num)) + ((((-value1->X + (3.0f * value2->X)) - (3.0f * value3->X)) + value4->X) * num2));
				vector->Y = 0.5f * ((((2.0f * value2->Y) + ((-value1->Y + value3->Y) * amount)) + (((((2.0f * value1->Y) - (5.0f * value2->Y)) + (4.0f * value3->Y)) - value4->Y) * num)) + ((((-value1->Y + (3.0f * value2->Y)) - (3.0f * value3->Y)) + value4->Y) * num2));
				return vector;
			}

			void Vector2::CatmullRom(Vector2 ^%value1, Vector2 ^%value2, Vector2 ^%value3, Vector2 ^%value4, float amount, [Out] Vector2 ^%result)
			{
				float num = amount * amount;
				float num2 = amount * num;
				result->X = 0.5f * ((((2.0f * value2->X) + ((-value1->X + value3->X) * amount)) + (((((2.0f * value1->X) - (5.0f * value2->X)) + (4.0f * value3->X)) - value4->X) * num)) + ((((-value1->X + (3.0f * value2->X)) - (3.0f * value3->X)) + value4->X) * num2));
				result->Y = 0.5f * ((((2.0f * value2->Y) + ((-value1->Y + value3->Y) * amount)) + (((((2.0f * value1->Y) - (5.0f * value2->Y)) + (4.0f * value3->Y)) - value4->Y) * num)) + ((((-value1->Y + (3.0f * value2->Y)) - (3.0f * value3->Y)) + value4->Y) * num2));
			}

			Vector2^ Vector2::Hermite(Vector2 ^value1, Vector2 ^tangent1, Vector2 ^value2, Vector2 ^tangent2, float amount)
			{
				Vector2 ^vector;
				float num = amount * amount;
				float num2 = amount * num;
				float num6 = ((2.0f * num2) - (3.0f * num)) + 1.0f;
				float num5 = (-2.0f * num2) + (3.0f * num);
				float num4 = (num2 - (2.0f * num)) + amount;
				float num3 = num2 - num;
				vector->X = (((value1->X * num6) + (value2->X * num5)) + (tangent1->X * num4)) + (tangent2->X * num3);
				vector->Y = (((value1->Y * num6) + (value2->Y * num5)) + (tangent1->Y * num4)) + (tangent2->Y * num3);
				return vector;
			}

			void Vector2::Hermite(Vector2 ^%value1, Vector2 ^%tangent1, Vector2 ^%value2, Vector2 ^%tangent2, float amount, [Out] Vector2 ^%result)
			{
				float num = amount * amount;
				float num2 = amount * num;
				float num6 = ((2.0f * num2) - (3.0f * num)) + 1.0f;
				float num5 = (-2.0f * num2) + (3.0f * num);
				float num4 = (num2 - (2.0f * num)) + amount;
				float num3 = num2 - num;
				result->X = (((value1->X * num6) + (value2->X * num5)) + (tangent1->X * num4)) + (tangent2->X * num3);
				result->Y = (((value1->Y * num6) + (value2->Y * num5)) + (tangent1->Y * num4)) + (tangent2->Y * num3);
			}

			Vector2^ Vector2::Transform(Vector2 ^position, Matrix ^matrix)
			{
				return gcnew Vector2();
			}

			void Vector2::Transform(Vector2 ^%position, Matrix ^%matrix, [Out] Vector2 ^%result)
			{

			}

			Vector2^ Vector2::TransformNormal(Vector2 ^normal, Matrix ^matrix)
			{
				return gcnew Vector2();
			}

			void Vector2::TransformNormal(Vector2 ^%normal, Matrix ^%matrix, [Out] Vector2 ^%result)
			{

			}

			Vector2^ Vector2::Transform(Vector2 ^value, Quaternion ^rotation)
			{
				return gcnew Vector2();
			}

			void Vector2::Transform(Vector2 ^%value, Quaternion ^%rotation, [Out] Vector2 ^%result)
			{

			}

			void Vector2::Transform(array<Vector2> ^sourceArray, Matrix ^%matrix, array<Vector2> ^destinationArray)
			{

			}

			[SuppressMessage("Microsoft.Usage", "CA2233")]
			void Vector2::Transform(array<Vector2> ^sourceArray, int sourceIndex, Matrix ^%matrix, array<Vector2> ^destinationArray, int destinationIndex, int length)
			{

			}

			void Vector2::TransformNormal(array<Vector2> ^sourceArray, Matrix ^%matrix, array<Vector2> ^destinationArray)
			{

			}

			[SuppressMessage("Microsoft.Usage", "CA2233")]
			void Vector2::TransformNormal(array<Vector2> ^sourceArray, int sourceIndex, Matrix ^%matrix, array<Vector2> ^destinationArray, int destinationIndex, int length)
			{

			}

			void Vector2::Transform(array<Vector2> ^sourceArray, Quaternion ^%rotation, array<Vector2> ^destinationArray)
			{

			}

			[SuppressMessage("Microsoft.Usage", "CA2233")]
			void Vector2::Transform(array<Vector2> ^sourceArray, int sourceIndex, Quaternion ^%rotation, array<Vector2> ^destinationArray, int destinationIndex, int length)
			{

			}

			Vector2^ Vector2::Negate(Vector2 ^value)
			{
				Vector2 ^vector;
				vector->X = -value->X;
				vector->Y = -value->Y;
				return vector;
			}

			void Vector2::Negate(Vector2 ^%value, [Out] Vector2 ^%result)
			{
				result->X = -value->X;
				result->Y = -value->Y;
			}

			Vector2^ Vector2::Add(Vector2 ^value1, Vector2 ^value2)
			{
				Vector2 ^vector;
				vector->X = value1->X + value2->X;
				vector->Y = value1->Y + value2->Y;
				return vector;
			}

			void Vector2::Add(Vector2 ^%value1, Vector2 ^%value2, [Out] Vector2 ^%result)
			{
				result->X = value1->X + value2->X;
				result->Y = value1->Y + value2->Y;
			}

			Vector2^ Vector2::Subtract(Vector2 ^value1, Vector2 ^value2)
			{
				Vector2 ^vector;
				vector->X = value1->X - value2->X;
				vector->Y = value1->Y - value2->Y;
				return vector;
			}

			void Vector2::Subtract(Vector2 ^%value1, Vector2 ^%value2, [Out] Vector2 ^%result)
			{
				result->X = value1->X - value2->X;
				result->Y = value1->Y - value2->Y;
			}

			Vector2^ Vector2::Multiply(Vector2 ^value1, Vector2 ^value2)
			{
				Vector2 ^vector;
				vector->X = value1->X * value2->X;
				vector->Y = value1->Y * value2->Y;
				return vector;
			}

			void Vector2::Multiply(Vector2 ^%value1, Vector2 ^%value2, [Out] Vector2 ^%result)
			{
				result->X = value1->X * value2->X;
				result->Y = value1->Y * value2->Y;
			}

			Vector2^ Vector2::Multiply(Vector2 ^value1, float scaleFactor)
			{
				Vector2 ^vector;
				vector->X = value1->X * scaleFactor;
				vector->Y = value1->Y * scaleFactor;
				return vector;
			}

			void Vector2::Multiply(Vector2 ^%value1, float scaleFactor, [Out] Vector2 ^%result)
			{
				result->X = value1->X * scaleFactor;
				result->Y = value1->Y * scaleFactor;
			}

			Vector2^ Vector2::Divide(Vector2 ^value1, Vector2 ^value2)
			{
				Vector2 ^vector;
				vector->X = value1->X / value2->X;
				vector->Y = value1->Y / value2->Y;
				return vector;
			}

			void Vector2::Divide(Vector2 ^%value1, Vector2 ^%value2, [Out] Vector2 ^%result)
			{
				result->X = value1->X / value2->X;
				result->Y = value1->Y / value2->Y;
			}

			Vector2^ Vector2::Divide(Vector2 ^value1, float divider)
			{
				Vector2 ^vector;
				float num = 1.0f / divider;
				vector->X = value1->X * num;
				vector->Y = value1->Y * num;
				return vector;
			}

			void Vector2::Divide(Vector2 ^%value1, float divider, [Out] Vector2 ^%result)
			{
				float num = 1.0f / divider;
				result->X = value1->X * num;
				result->Y = value1->Y * num;
			}

			Vector2^ Vector2::operator -(Vector2 ^value)
			{
				Vector2 ^vector;
				vector->X = -value->X;
				vector->Y = -value->Y;
				return vector;
			}

			bool Vector2::operator ==(Vector2 ^value1, Vector2 ^value2)
			{
				return ((value1->X == value2->X) && (value1->Y == value2->Y));
			}

			bool Vector2::operator !=(Vector2 ^value1, Vector2 ^value2)
			{
				if (value1->X == value2->X)
				{
					return !(value1->Y == value2->Y);
				}
				return true;
			}

			Vector2^ Vector2::operator +(Vector2 ^value1, Vector2 ^value2)
			{
				Vector2 ^vector;
				vector->X = value1->X + value2->X;
				vector->Y = value1->Y + value2->Y;
				return vector;
			}

			Vector2^ Vector2::operator -(Vector2 ^value1, Vector2 ^value2)
			{
				Vector2 ^vector;
				vector->X = value1->X - value2->X;
				vector->Y = value1->Y - value2->Y;
				return vector;
			}

			Vector2^ Vector2::operator *(Vector2 ^value1, Vector2 ^value2)
			{
				Vector2 ^vector;
				vector->X = value1->X * value2->X;
				vector->Y = value1->Y * value2->Y;
				return vector;
			}

			Vector2^ Vector2::operator *(Vector2 ^value, float scaleFactor)
			{
				Vector2 ^vector;
				vector->X = value->X * scaleFactor;
				vector->Y = value->Y * scaleFactor;
				return vector;
			}

			Vector2^ Vector2::operator *(float scaleFactor, Vector2 ^value)
			{
				Vector2 ^vector;
				vector->X = value->X * scaleFactor;
				vector->Y = value->Y * scaleFactor;
				return vector;
			}

			Vector2^ Vector2::operator /(Vector2 ^value1, Vector2 ^value2)
			{
				Vector2 ^vector;
				vector->X = value1->X / value2->X;
				vector->Y = value1->Y / value2->Y;
				return vector;
			}

			Vector2^ Vector2::operator /(Vector2 ^value1, float divider)
			{
				Vector2 ^vector;
				float num = 1.0f / divider;
				vector->X = value1->X * num;
				vector->Y = value1->Y * num;
				return vector;
			}

			static Vector2::Vector2()
			{
				Vector2::_zero = gcnew Vector2();
				Vector2::_one = gcnew Vector2(1.0f, 1.0f);
				Vector2::_unitX = gcnew Vector2(1.0f, 0.0f);
				Vector2::_unitY = gcnew Vector2(0.0f, 1.0f);
			}
		}
	}
}
