#include "stdafx.h"

using namespace System::Globalization;

#include "Vector3.h"

namespace Microsoft {
	namespace Xna {
		namespace Framework {
			Vector3::Vector3(float x, float y, float z)
			{
				this->X = x;
				this->Y = y;
				this->Z = z;
			}

			Vector3::Vector3(Vector2 ^value, float z)
			{
				this->X = value->X;
				this->Y = value->Y;
				this->Z = z;
			}

			Vector3::Vector3(float value)
			{
				this->X = this->Y = this->Z = value;
			}

			String^ Vector3::ToString()
			{
				CultureInfo ^currentCulture = CultureInfo::CurrentCulture;
				//return String::Format(currentCulture, "{{X:{0} Y:{1} Z:{2}}}", gcnew array<Object^> { this->X->ToString(currentCulture), this->Y->ToString(currentCulture), this->Z->ToString(currentCulture) });
				return L"";
			}

			bool Vector3::Equals(Vector3 ^other)
			{
				return (((this->X == other->X) && (this->Y == other->Y)) && (this->Z == other->Z));
			}

			bool Vector3::Equals(Object ^obj)
			{
				bool flag = false;
				/*if (obj is Vector3)
				{
					flag = this->Equals((Vector3^) obj);
				}*/
				return flag;
			}

			int Vector3::GetHashCode()
			{
				//return ((this->X->GetHashCode() + this->Y->GetHashCode()) + this->Z->GetHashCode());
				return 1;
			}

			float Vector3::Length()
			{
				float num = ((this->X * this->X) + (this->Y * this->Y)) + (this->Z * this->Z);
				return (float) Math::Sqrt((double) num);
			}

			float Vector3::LengthSquared()
			{
				return (((this->X * this->X) + (this->Y * this->Y)) + (this->Z * this->Z));
			}

			float Vector3::Distance(Vector3 ^value1, Vector3 ^value2)
			{
				float num3 = value1->X - value2->X;
				float num2 = value1->Y - value2->Y;
				float num = value1->Z - value2->Z;
				float num4 = ((num3 * num3) + (num2 * num2)) + (num * num);
				return (float) Math::Sqrt((double) num4);
			}

			void Vector3::Distance(Vector3 ^%value1, Vector3 ^%value2, [Out] float ^%result)
			{
				float num3 = value1->X - value2->X;
				float num2 = value1->Y - value2->Y;
				float num = value1->Z - value2->Z;
				float num4 = ((num3 * num3) + (num2 * num2)) + (num * num);
				result = (float) Math::Sqrt((double) num4);
			}

			float Vector3::DistanceSquared(Vector3 ^value1, Vector3 ^value2)
			{
				float num3 = value1->X - value2->X;
				float num2 = value1->Y - value2->Y;
				float num = value1->Z - value2->Z;
				return (((num3 * num3) + (num2 * num2)) + (num * num));
			}

			void Vector3::DistanceSquared(Vector3 ^%value1, Vector3 ^%value2, [Out] float ^%result)
			{
				float num3 = value1->X - value2->X;
				float num2 = value1->Y - value2->Y;
				float num = value1->Z - value2->Z;
				result = ((num3 * num3) + (num2 * num2)) + (num * num);
			}

			float Vector3::Dot(Vector3 ^vector1, Vector3 ^vector2)
			{
				return (((vector1->X * vector2->X) + (vector1->Y * vector2->Y)) + (vector1->Z * vector2->Z));
			}

			void Vector3::Dot(Vector3 ^%vector1, Vector3 ^%vector2, [Out] float ^%result)
			{
				result = ((vector1->X * vector2->X) + (vector1->Y * vector2->Y)) + (vector1->Z * vector2->Z);
			}

			void Vector3::Normalize()
			{
				float num2 = ((this->X * this->X) + (this->Y * this->Y)) + (this->Z * this->Z);
				float num = 1.0f / ((float) Math::Sqrt((double) num2));
				this->X *= num;
				this->Y *= num;
				this->Z *= num;
			}

			Vector3^ Vector3::Normalize(Vector3 ^value)
			{
				Vector3^ vector;
				float num2 = ((value->X * value->X) + (value->Y * value->Y)) + (value->Z * value->Z);
				float num = 1.0f / ((float) Math::Sqrt((double) num2));
				vector->X = value->X * num;
				vector->Y = value->Y * num;
				vector->Z = value->Z * num;
				return vector;
			}

			void Vector3::Normalize(Vector3 ^%value, [Out] Vector3 ^%result)
			{
				float num2 = ((value->X * value->X) + (value->Y * value->Y)) + (value->Z * value->Z);
				float num = 1.0f / ((float) Math::Sqrt((double) num2));
				result->X = value->X * num;
				result->Y = value->Y * num;
				result->Z = value->Z * num;
			}

			Vector3^ Vector3::Cross(Vector3 ^vector1, Vector3 ^vector2)
			{
				Vector3 ^vector;
				vector->X = (vector1->Y * vector2->Z) - (vector1->Z * vector2->Y);
				vector->Y = (vector1->Z * vector2->X) - (vector1->X * vector2->Z);
				vector->Z = (vector1->X * vector2->Y) - (vector1->Y * vector2->X);
				return vector;
			}

			void Vector3::Cross(Vector3 ^%vector1, Vector3 ^%vector2, [Out] Vector3 ^%result)
			{
				float num3 = (vector1->Y * vector2->Z) - (vector1->Z * vector2->Y);
				float num2 = (vector1->Z * vector2->X) - (vector1->X * vector2->Z);
				float num = (vector1->X * vector2->Y) - (vector1->Y * vector2->X);
				result->X = num3;
				result->Y = num2;
				result->Z = num;
			}

			Vector3^ Vector3::Reflect(Vector3 ^vector, Vector3 ^normal)
			{
				Vector3 ^vector2;
				float num = ((vector->X * normal->X) + (vector->Y * normal->Y)) + (vector->Z * normal->Z);
				vector2->X = vector->X - ((2.0f * num) * normal->X);
				vector2->Y = vector->Y - ((2.0f * num) * normal->Y);
				vector2->Z = vector->Z - ((2.0f * num) * normal->Z);
				return vector2;
			}

			void Vector3::Reflect(Vector3 ^%vector, Vector3 ^%normal, [Out] Vector3 ^%result)
			{
				float num = ((vector->X * normal->X) + (vector->Y * normal->Y)) + (vector->Z * normal->Z);
				result->X = vector->X - ((2.0f * num) * normal->X);
				result->Y = vector->Y - ((2.0f * num) * normal->Y);
				result->Z = vector->Z - ((2.0f * num) * normal->Z);
			}

			Vector3^ Vector3::Min(Vector3 ^value1, Vector3 ^value2)
			{
				Vector3 ^vector;
				vector->X = (value1->X < value2->X) ? value1->X : value2->X;
				vector->Y = (value1->Y < value2->Y) ? value1->Y : value2->Y;
				vector->Z = (value1->Z < value2->Z) ? value1->Z : value2->Z;
				return vector;
			}

			void Vector3::Min(Vector3 ^%value1, Vector3 ^%value2, [Out] Vector3 ^%result)
			{
				result->X = (value1->X < value2->X) ? value1->X : value2->X;
				result->Y = (value1->Y < value2->Y) ? value1->Y : value2->Y;
				result->Z = (value1->Z < value2->Z) ? value1->Z : value2->Z;
			}

			Vector3^ Vector3::Max(Vector3 ^value1, Vector3 ^value2)
			{
				Vector3 ^vector;
				vector->X = (value1->X > value2->X) ? value1->X : value2->X;
				vector->Y = (value1->Y > value2->Y) ? value1->Y : value2->Y;
				vector->Z = (value1->Z > value2->Z) ? value1->Z : value2->Z;
				return vector;
			}

			void Vector3::Max(Vector3 ^%value1, Vector3 ^%value2, [Out] Vector3 ^%result)
			{
				result->X = (value1->X > value2->X) ? value1->X : value2->X;
				result->Y = (value1->Y > value2->Y) ? value1->Y : value2->Y;
				result->Z = (value1->Z > value2->Z) ? value1->Z : value2->Z;
			}

			Vector3^ Vector3::Clamp(Vector3 ^value1, Vector3 ^min, Vector3 ^max)
			{
				Vector3 ^vector;
				float x = value1->X;
				x = (x > max->X) ? max->X : x;
				x = (x < min->X) ? min->X : x;
				float y = value1->Y;
				y = (y > max->Y) ? max->Y : y;
				y = (y < min->Y) ? min->Y : y;
				float z = value1->Z;
				z = (z > max->Z) ? max->Z : z;
				z = (z < min->Z) ? min->Z : z;
				vector->X = x;
				vector->Y = y;
				vector->Z = z;
				return vector;
			}

			void Vector3::Clamp(Vector3 ^%value1, Vector3 ^%min, Vector3 ^%max, [Out] Vector3 ^%result)
			{
				float x = value1->X;
				x = (x > max->X) ? max->X : x;
				x = (x < min->X) ? min->X : x;
				float y = value1->Y;
				y = (y > max->Y) ? max->Y : y;
				y = (y < min->Y) ? min->Y : y;
				float z = value1->Z;
				z = (z > max->Z) ? max->Z : z;
				z = (z < min->Z) ? min->Z : z;
				result->X = x;
				result->Y = y;
				result->Z = z;
			}

			Vector3^ Vector3::Lerp(Vector3 ^value1, Vector3 ^value2, float amount)
			{
				Vector3 ^vector;
				vector->X = value1->X + ((value2->X - value1->X) * amount);
				vector->Y = value1->Y + ((value2->Y - value1->Y) * amount);
				vector->Z = value1->Z + ((value2->Z - value1->Z) * amount);
				return vector;
			}

			void Vector3::Lerp(Vector3 ^%value1, Vector3 ^%value2, float amount, [Out] Vector3 ^%result)
			{
				result->X = value1->X + ((value2->X - value1->X) * amount);
				result->Y = value1->Y + ((value2->Y - value1->Y) * amount);
				result->Z = value1->Z + ((value2->Z - value1->Z) * amount);
			}

			Vector3^ Vector3::Barycentric(Vector3 ^value1, Vector3 ^value2, Vector3 ^value3, float amount1, float amount2)
			{
				Vector3 ^vector;
				vector->X = (value1->X + (amount1 * (value2->X - value1->X))) + (amount2 * (value3->X - value1->X));
				vector->Y = (value1->Y + (amount1 * (value2->Y - value1->Y))) + (amount2 * (value3->Y - value1->Y));
				vector->Z = (value1->Z + (amount1 * (value2->Z - value1->Z))) + (amount2 * (value3->Z - value1->Z));
				return vector;
			}

			void Vector3::Barycentric(Vector3 ^%value1, Vector3 ^%value2, Vector3 ^%value3, float amount1, float amount2, [Out] Vector3 ^%result)
			{
				result->X = (value1->X + (amount1 * (value2->X - value1->X))) + (amount2 * (value3->X - value1->X));
				result->Y = (value1->Y + (amount1 * (value2->Y - value1->Y))) + (amount2 * (value3->Y - value1->Y));
				result->Z = (value1->Z + (amount1 * (value2->Z - value1->Z))) + (amount2 * (value3->Z - value1->Z));
			}

			Vector3^ Vector3::SmoothStep(Vector3 ^value1, Vector3 ^value2, float amount)
			{
				Vector3 ^vector;
				amount = (amount > 1.0f) ? 1.0f : ((amount < 0.0f) ? 0.0f : amount);
				amount = (amount * amount) * (3.0f - (2.0f * amount));
				vector->X = value1->X + ((value2->X - value1->X) * amount);
				vector->Y = value1->Y + ((value2->Y - value1->Y) * amount);
				vector->Z = value1->Z + ((value2->Z - value1->Z) * amount);
				return vector;
			}

			void Vector3::SmoothStep(Vector3 ^%value1, Vector3 ^%value2, float amount, [Out] Vector3 ^%result)
			{
				amount = (amount > 1.0f) ? 1.0f : ((amount < 0.0f) ? 0.0f : amount);
				amount = (amount * amount) * (3.0f - (2.0f * amount));
				result->X = value1->X + ((value2->X - value1->X) * amount);
				result->Y = value1->Y + ((value2->Y - value1->Y) * amount);
				result->Z = value1->Z + ((value2->Z - value1->Z) * amount);
			}

			Vector3^ Vector3::CatmullRom(Vector3 ^value1, Vector3 ^value2, Vector3 ^value3, Vector3 ^value4, float amount)
			{
				Vector3 ^vector;
				float num = amount * amount;
				float num2 = amount * num;
				vector->X = 0.5f * ((((2.0f * value2->X) + ((-value1->X + value3->X) * amount)) + (((((2.0f * value1->X) - (5.0f * value2->X)) + (4.0f * value3->X)) - value4->X) * num)) + ((((-value1->X + (3.0f * value2->X)) - (3.0f * value3->X)) + value4->X) * num2));
				vector->Y = 0.5f * ((((2.0f * value2->Y) + ((-value1->Y + value3->Y) * amount)) + (((((2.0f * value1->Y) - (5.0f * value2->Y)) + (4.0f * value3->Y)) - value4->Y) * num)) + ((((-value1->Y + (3.0f * value2->Y)) - (3.0f * value3->Y)) + value4->Y) * num2));
				vector->Z = 0.5f * ((((2.0f * value2->Z) + ((-value1->Z + value3->Z) * amount)) + (((((2.0f * value1->Z) - (5.0f * value2->Z)) + (4.0f * value3->Z)) - value4->Z) * num)) + ((((-value1->Z + (3.0f * value2->Z)) - (3.0f * value3->Z)) + value4->Z) * num2));
				return vector;
			}

			void Vector3::CatmullRom(Vector3 ^%value1, Vector3 ^%value2, Vector3 ^%value3, Vector3 ^%value4, float amount, [Out] Vector3 ^%result)
			{
				float num = amount * amount;
				float num2 = amount * num;
				result->X = 0.5f * ((((2.0f * value2->X) + ((-value1->X + value3->X) * amount)) + (((((2.0f * value1->X) - (5.0f * value2->X)) + (4.0f * value3->X)) - value4->X) * num)) + ((((-value1->X + (3.0f * value2->X)) - (3.0f * value3->X)) + value4->X) * num2));
				result->Y = 0.5f * ((((2.0f * value2->Y) + ((-value1->Y + value3->Y) * amount)) + (((((2.0f * value1->Y) - (5.0f * value2->Y)) + (4.0f * value3->Y)) - value4->Y) * num)) + ((((-value1->Y + (3.0f * value2->Y)) - (3.0f * value3->Y)) + value4->Y) * num2));
				result->Z = 0.5f * ((((2.0f * value2->Z) + ((-value1->Z + value3->Z) * amount)) + (((((2.0f * value1->Z) - (5.0f * value2->Z)) + (4.0f * value3->Z)) - value4->Z) * num)) + ((((-value1->Z + (3.0f * value2->Z)) - (3.0f * value3->Z)) + value4->Z) * num2));
			}

			Vector3^ Vector3::Hermite(Vector3 ^value1, Vector3 ^tangent1, Vector3 ^value2, Vector3 ^tangent2, float amount)
			{
				Vector3 ^vector;
				float num = amount * amount;
				float num2 = amount * num;
				float num6 = ((2.0f * num2) - (3.0f * num)) + 1.0f;
				float num5 = (-2.0f * num2) + (3.0f * num);
				float num4 = (num2 - (2.0f * num)) + amount;
				float num3 = num2 - num;
				vector->X = (((value1->X * num6) + (value2->X * num5)) + (tangent1->X * num4)) + (tangent2->X * num3);
				vector->Y = (((value1->Y * num6) + (value2->Y * num5)) + (tangent1->Y * num4)) + (tangent2->Y * num3);
				vector->Z = (((value1->Z * num6) + (value2->Z * num5)) + (tangent1->Z * num4)) + (tangent2->Z * num3);
				return vector;
			}

			void Vector3::Hermite(Vector3 ^%value1, Vector3 ^%tangent1, Vector3 ^%value2, Vector3 ^%tangent2, float amount, [Out] Vector3 ^%result)
			{
				float num = amount * amount;
				float num2 = amount * num;
				float num6 = ((2.0f * num2) - (3.0f * num)) + 1.0f;
				float num5 = (-2.0f * num2) + (3.0f * num);
				float num4 = (num2 - (2.0f * num)) + amount;
				float num3 = num2 - num;
				result->X = (((value1->X * num6) + (value2->X * num5)) + (tangent1->X * num4)) + (tangent2->X * num3);
				result->Y = (((value1->Y * num6) + (value2->Y * num5)) + (tangent1->Y * num4)) + (tangent2->Y * num3);
				result->Z = (((value1->Z * num6) + (value2->Z * num5)) + (tangent1->Z * num4)) + (tangent2->Z * num3);
			}

			Vector3^ Vector3::Transform(Vector3 position, Matrix matrix)
			{
				return gcnew Vector3();
			}

			void Vector3::Transform(Vector3 ^%position, Matrix ^%matrix, [Out] Vector3 ^%result)
			{
				
			}

			Vector3^ Vector3::TransformNormal(Vector3 normal, Matrix matrix)
			{
				return gcnew Vector3();
			}

			void Vector3::TransformNormal(Vector3 ^%normal, Matrix ^%matrix, [Out] Vector3 ^%result)
			{
				
			}

			Vector3^ Vector3::Transform(Vector3 value, Quaternion rotation)
			{
				return gcnew Vector3();
			}

			void Vector3::Transform(Vector3 ^%value, Quaternion ^%rotation, [Out] Vector3 ^%result)
			{
				
			}

			void Vector3::Transform(array<Vector3> ^sourceArray, Matrix ^%matrix, array<Vector3> ^destinationArray)
			{
				
			}

			[SuppressMessage("Microsoft.Usage", "CA2233")]
			void Vector3::Transform(array<Vector3> ^sourceArray, int sourceIndex, Matrix ^%matrix, array<Vector3> ^destinationArray, int destinationIndex, int length)
			{
				
			}

			void Vector3::TransformNormal(array<Vector3> ^sourceArray, Matrix ^%matrix, array<Vector3> ^destinationArray)
			{
				
			}

			[SuppressMessage("Microsoft.Usage", "CA2233")]
			void Vector3::TransformNormal(array<Vector3> ^sourceArray, int sourceIndex, Matrix ^%matrix, array<Vector3> ^destinationArray, int destinationIndex, int length)
			{
				
			}

			void Vector3::Transform(array<Vector3> ^sourceArray, Quaternion ^%rotation, array<Vector3> ^destinationArray)
			{
				
			}

			[SuppressMessage("Microsoft.Usage", "CA2233")]
			void Vector3::Transform(array<Vector3> ^sourceArray, int sourceIndex, Quaternion ^%rotation, array<Vector3> ^destinationArray, int destinationIndex, int length)
			{
				
			}

			Vector3^ Vector3::Negate(Vector3 ^value)
			{
				Vector3 ^vector;
				vector->X = -value->X;
				vector->Y = -value->Y;
				vector->Z = -value->Z;
				return vector;
			}

			void Vector3::Negate(Vector3 ^%value, [Out] Vector3 ^%result)
			{
				result->X = -value->X;
				result->Y = -value->Y;
				result->Z = -value->Z;
			}

			Vector3^ Vector3::Add(Vector3 ^value1, Vector3 ^value2)
			{
				Vector3 ^vector;
				vector->X = value1->X + value2->X;
				vector->Y = value1->Y + value2->Y;
				vector->Z = value1->Z + value2->Z;
				return vector;
			}

			void Vector3::Add(Vector3 ^%value1, Vector3 ^%value2, [Out] Vector3 ^%result)
			{
				result->X = value1->X + value2->X;
				result->Y = value1->Y + value2->Y;
				result->Z = value1->Z + value2->Z;
			}

			Vector3^ Vector3::Subtract(Vector3 ^value1, Vector3 ^value2)
			{
				Vector3 ^vector;
				vector->X = value1->X - value2->X;
				vector->Y = value1->Y - value2->Y;
				vector->Z = value1->Z - value2->Z;
				return vector;
			}

			void Vector3::Subtract(Vector3 ^%value1, Vector3 ^%value2, [Out] Vector3 ^%result)
			{
				result->X = value1->X - value2->X;
				result->Y = value1->Y - value2->Y;
				result->Z = value1->Z - value2->Z;
			}

			Vector3^ Vector3::Multiply(Vector3 ^value1, Vector3 ^value2)
			{
				Vector3 ^vector;
				vector->X = value1->X * value2->X;
				vector->Y = value1->Y * value2->Y;
				vector->Z = value1->Z * value2->Z;
				return vector;
			}

			void Vector3::Multiply(Vector3 ^%value1, Vector3 ^%value2, [Out] Vector3 ^%result)
			{
				result->X = value1->X * value2->X;
				result->Y = value1->Y * value2->Y;
				result->Z = value1->Z * value2->Z;
			}

			Vector3^ Vector3::Multiply(Vector3 ^value1, float scaleFactor)
			{
				Vector3 ^vector;
				vector->X = value1->X * scaleFactor;
				vector->Y = value1->Y * scaleFactor;
				vector->Z = value1->Z * scaleFactor;
				return vector;
			}

			void Vector3::Multiply(Vector3 ^%value1, float scaleFactor, [Out] Vector3 ^%result)
			{
				result->X = value1->X * scaleFactor;
				result->Y = value1->Y * scaleFactor;
				result->Z = value1->Z * scaleFactor;
			}

			Vector3^ Vector3::Divide(Vector3 ^value1, Vector3 ^value2)
			{
				Vector3 ^vector;
				vector->X = value1->X / value2->X;
				vector->Y = value1->Y / value2->Y;
				vector->Z = value1->Z / value2->Z;
				return vector;
			}

			void Vector3::Divide(Vector3 ^%value1, Vector3 ^%value2, [Out] Vector3 ^%result)
			{
				result->X = value1->X / value2->X;
				result->Y = value1->Y / value2->Y;
				result->Z = value1->Z / value2->Z;
			}

			Vector3^ Vector3::Divide(Vector3 ^value1, float divider)
			{
				Vector3 ^vector;
				float num = 1.0f / divider;
				vector->X = value1->X * num;
				vector->Y = value1->Y * num;
				vector->Z = value1->Z * num;
				return vector;
			}

			void Vector3::Divide(Vector3 ^%value1, float divider, [Out] Vector3 ^%result)
			{
				float num = 1.0f / divider;
				result->X = value1->X * num;
				result->Y = value1->Y * num;
				result->Z = value1->Z * num;
			}

			Vector3^ Vector3::operator -(Vector3 ^value)
			{
				Vector3 ^vector;
				vector->X = -value->X;
				vector->Y = -value->Y;
				vector->Z = -value->Z;
				return vector;
			}

			bool Vector3::operator ==(Vector3 ^value1, Vector3 ^value2)
			{
				return (((value1->X == value2->X) && (value1->Y == value2->Y)) && (value1->Z == value2->Z));
			}

			bool Vector3::operator !=(Vector3 ^value1, Vector3 ^value2)
			{
				if ((value1->X == value2->X) && (value1->Y == value2->Y))
				{
					return !(value1->Z == value2->Z);
				}
				return true;
			}

			Vector3^ Vector3::operator +(Vector3 ^value1, Vector3 ^value2)
			{
				Vector3 ^vector;
				vector->X = value1->X + value2->X;
				vector->Y = value1->Y + value2->Y;
				vector->Z = value1->Z + value2->Z;
				return vector;
			}

			Vector3^ Vector3::operator -(Vector3 ^value1, Vector3 ^value2)
			{
				Vector3 ^vector;
				vector->X = value1->X - value2->X;
				vector->Y = value1->Y - value2->Y;
				vector->Z = value1->Z - value2->Z;
				return vector;
			}

			Vector3^ Vector3::operator *(Vector3 ^value1, Vector3 ^value2)
			{
				Vector3 ^vector;
				vector->X = value1->X * value2->X;
				vector->Y = value1->Y * value2->Y;
				vector->Z = value1->Z * value2->Z;
				return vector;
			}

			Vector3^ Vector3::operator *(Vector3 ^value1, float scaleFactor)
			{
				Vector3 ^vector;
				vector->X = value1->X * scaleFactor;
				vector->Y = value1->Y * scaleFactor;
				vector->Z = value1->Z * scaleFactor;
				return vector;
			}

			Vector3^ Vector3::operator *(float scaleFactor, Vector3 ^value1)
			{
				Vector3 ^vector;
				vector->X = value1->X * scaleFactor;
				vector->Y = value1->Y * scaleFactor;
				vector->Z = value1->Z * scaleFactor;
				return vector;
			}

			Vector3^ Vector3::operator /(Vector3 ^value1, Vector3 ^value2)
			{
				Vector3 ^vector;
				vector->X = value1->X / value2->X;
				vector->Y = value1->Y / value2->Y;
				vector->Z = value1->Z / value2->Z;
				return vector;
			}

			Vector3^ Vector3::operator / (Vector3 ^value1, float divider)
			{
				Vector3 ^vector;
				float num = 1.0f / divider;
				vector->X = value1->X * num;
				vector->Y = value1->Y * num;
				vector->Z = value1->Z * num;
				return vector;
			}

			static Vector3::Vector3()
			{
				Vector3::_zero = gcnew Vector3();
				Vector3::_one = gcnew Vector3(1.0f, 1.0f, 1.0f);
				Vector3::_unitX = gcnew Vector3(1.0f, 0.0f, 0.0f);
				Vector3::_unitY = gcnew Vector3(0.0f, 1.0f, 0.0f);
				Vector3::_unitZ = gcnew Vector3(0.0f, 0.0f, 1.0f);
				Vector3::_up = gcnew Vector3(0.0f, 1.0f, 0.0f);
				Vector3::_down = gcnew Vector3(0.0f, -1.0f, 0.0f);
				Vector3::_right = gcnew Vector3(1.0f, 0.0f, 0.0f);
				Vector3::_left = gcnew Vector3(-1.0f, 0.0f, 0.0f);
				Vector3::_forward = gcnew Vector3(0.0f, 0.0f, -1.0f);
				Vector3::_backward = gcnew Vector3(0.0f, 0.0f, 1.0f);
			}
		}
	}
}
