#include "stdafx.h"

using namespace System;
using namespace System::Diagnostics::CodeAnalysis;
using namespace System::Runtime::InteropServices;
using namespace System::Globalization;

#include "Vector4.h"

namespace Microsoft {
	namespace Xna {
		namespace Framework {
			Vector4::Vector4(float x, float y, float z, float w)
			{
				this->X = x;
				this->Y = y;
				this->Z = z;
				this->W = w;
			}

			Vector4::Vector4(Vector2 ^value, float z, float w)
			{
				this->X = value->X;
				this->Y = value->Y;
				this->Z = z;
				this->W = w;
			}

			Vector4::Vector4(Vector3 ^value, float w)
			{
				this->X = value->X;
				this->Y = value->Y;
				this->Z = value->Z;
				this->W = w;
			}

			Vector4::Vector4(float value)
			{
				this->X = value;
				this->Y = value;
				this->Z = value;
				this->W = value;
			}

			String^ Vector4::ToString()
			{
				CultureInfo ^currentCulture = CultureInfo::CurrentCulture;
				//return String::Format(currentCulture, "{{X:{0} Y:{1} Z:{2} W:{3}}}", this->X->ToString(currentCulture), this->Y->ToString(currentCulture), this->Z->ToString(currentCulture), this->W->ToString(currentCulture));
				return L"";
			}


			bool Vector4::Equals(Vector4 ^other)
			{
				return ((((this->X == other->X) && (this->Y == other->Y)) && (this->Z == other->Z)) && (this->W == other->W));
			}

			bool Vector4::Equals(Object ^obj)
			{
				bool flag = false;
				/*if(obj is Vector4)
				{
					flag = this->Equals((Vector4) obj);
				}*/
				return flag;
			}

			int Vector4::GetHashCode()
			{
				//return (((this->X->GetHashCode() + this->Y->GetHashCode()) + this->Z->GetHashCode()) + this->W->GetHashCode());
				return 1;
			}

			float Vector4::Length()
			{
				float num = (((this->X * this->X) + (this->Y * this->Y)) + (this->Z * this->Z)) + (this->W * this->W);
				return (float) Math::Sqrt((double) num);
			}

			float Vector4::LengthSquared()
			{
				return ((((this->X * this->X) + (this->Y * this->Y)) + (this->Z * this->Z)) + (this->W * this->W));
			}

			float Vector4::Distance(Vector4 ^value1, Vector4 ^value2)
			{
				float num4 = value1->X - value2->X;
				float num3 = value1->Y - value2->Y;
				float num2 = value1->Z - value2->Z;
				float num = value1->W - value2->W;
				float num5 = (((num4 * num4) + (num3 * num3)) + (num2 * num2)) + (num * num);
				return (float) Math::Sqrt((double) num5);
			}

			void Vector4::Distance(Vector4 ^%value1, Vector4 ^%value2, [Out] float ^%result)
			{
				float num4 = value1->X - value2->X;
				float num3 = value1->Y - value2->Y;
				float num2 = value1->Z - value2->Z;
				float num = value1->W - value2->W;
				float num5 = (((num4 * num4) + (num3 * num3)) + (num2 * num2)) + (num * num);
				result = (float) Math::Sqrt((double) num5);
			}

			float Vector4::DistanceSquared(Vector4 ^value1, Vector4 ^value2)
			{
				float num4 = value1->X - value2->X;
				float num3 = value1->Y - value2->Y;
				float num2 = value1->Z - value2->Z;
				float num = value1->W - value2->W;
				return ((((num4 * num4) + (num3 * num3)) + (num2 * num2)) + (num * num));
			}

			void Vector4::DistanceSquared(Vector4 ^%value1, Vector4 ^%value2, [Out] float ^%result)
			{
				float num4 = value1->X - value2->X;
				float num3 = value1->Y - value2->Y;
				float num2 = value1->Z - value2->Z;
				float num = value1->W - value2->W;
				result = (((num4 * num4) + (num3 * num3)) + (num2 * num2)) + (num * num);
			}

			float Vector4::Dot(Vector4 ^vector1, Vector4 ^vector2)
			{
				return ((((vector1->X * vector2->X) + (vector1->Y * vector2->Y)) + (vector1->Z * vector2->Z)) + (vector1->W * vector2->W));
			}

			void Vector4::Dot(Vector4 ^%vector1, Vector4 ^%vector2, [Out] float ^%result)
			{
				result = ((((vector1->X * vector2->X) + (vector1->Y * vector2->Y)) + (vector1->Z * vector2->Z)) + (vector1->W * vector2->W));
			}

			void Vector4::Normalize()
			{
				float num2 = (((this->X * this->X) + (this->Y * this->Y)) + (this->Z * this->Z)) + (this->W * this->W);
				float num = 1.0f / ((float) Math::Sqrt((double) num2));
				this->X *= num;
				this->Y *= num;
				this->Z *= num;
				this->W *= num;
			}

			Vector4^ Vector4::Normalize(Vector4 ^vector)
			{
				Vector4 ^vector2;
				float num2 = (((vector->X * vector->X) + (vector->Y * vector->Y)) + (vector->Z * vector->Z)) + (vector->W * vector->W);
				float num = 1.0f / ((float) Math::Sqrt((double) num2));
				vector2->X = vector->X * num;
				vector2->Y = vector->Y * num;
				vector2->Z = vector->Z * num;
				vector2->W = vector->W * num;
				return vector2;
			}

			void Vector4::Normalize(Vector4 ^%vector, [Out] Vector4 ^%result)
			{
				float num2 = (((vector->X * vector->X) + (vector->Y * vector->Y)) + (vector->Z * vector->Z)) + (vector->W * vector->W);
				float num = 1.0f/ ((float) Math::Sqrt((double) num2));
				result->X = vector->X * num;
				result->Y = vector->Y * num;
				result->Z = vector->Z * num;
				result->W = vector->W * num;
			}

			Vector4^ Vector4::Min(Vector4 ^value1, Vector4 ^value2)
			{
				Vector4 ^vector;
				vector->X = (value1->X < value2->X) ? value1->X : value2->X;
				vector->Y = (value1->Y < value2->Y) ? value1->Y : value2->Y;
				vector->Z = (value1->Z < value2->Z) ? value1->Z : value2->Z;
				vector->W = (value1->W < value2->W) ? value1->W : value2->W;
				return vector;
			}

			void Vector4::Min(Vector4 ^%value1, Vector4 ^%value2, [Out] Vector4 ^%result)
			{
				result->X = (value1->X < value2->X) ? value1->X : value2->X;
				result->Y = (value1->Y < value2->Y) ? value1->Y : value2->Y;
				result->Z = (value1->Z < value2->Z) ? value1->Z : value2->Z;
				result->W = (value1->W < value2->W) ? value1->W : value2->W;
			}

			Vector4^ Vector4::Max(Vector4 ^value1, Vector4 ^value2)
			{
				Vector4 ^vector;
				vector->X = (value1->X > value2->X) ? value1->X : value2->X;
				vector->Y = (value1->Y > value2->Y) ? value1->Y : value2->Y;
				vector->Z = (value1->Z > value2->Z) ? value1->Z : value2->Z;
				vector->W = (value1->W > value2->W) ? value1->W : value2->W;
				return vector;
			}

			void Vector4::Max(Vector4 ^%value1, Vector4 ^%value2, [Out] Vector4 ^%result)
			{
				result->X = (value1->X > value2->X) ? value1->X : value2->X;
				result->Y = (value1->Y > value2->Y) ? value1->Y : value2->Y;
				result->Z = (value1->Z > value2->Z) ? value1->Z : value2->Z;
				result->W = (value1->W > value2->W) ? value1->W : value2->W;
			}

			Vector4^ Vector4::Clamp(Vector4 ^value1, Vector4 ^min, Vector4 ^max)
			{
				Vector4 ^vector;
				float x = value1->X;
				x = (x > max->X) ? max->X : x;
				x = (x < min->X) ? min->X : x;
				float y = value1->Y;
				y = (y > max->Y) ? max->Y : y;
				y = (y < min->Y) ? min->Y : y;
				float z = value1->Z;
				z = (z > max->Z) ? max->Z : z;
				z = (z < min->Z) ? min->Z : z;
				float w = value1->W;
				w = (w > max->W) ? max->W : w;
				w = (w < min->W) ? min->W : w;
				vector->X = x;
				vector->Y = y;
				vector->Z = z;
				vector->W = w;
				return vector;
			}

			void Vector4::Clamp(Vector4 ^%value1, Vector4 ^%min, Vector4 ^%max, [Out] Vector4 ^%result)
			{
				float x = value1->X;
				x = (x > max->X) ? max->X : x;
				x = (x < min->X) ? min->X : x;
				float y = value1->Y;
				y = (y > max->Y) ? max->Y : y;
				y = (y < min->Y) ? min->Y : y;
				float z = value1->Z;
				z = (z > max->Z) ? max->Z : z;
				z = (z < min->Z) ? min->Z : z;
				float w = value1->W;
				w = (w > max->W) ? max->W : w;
				w = (w < min->W) ? min->W : w;
				result->X = x;
				result->Y = y;
				result->Z = z;
				result->W = w;
			}

			Vector4^ Vector4::Lerp(Vector4 ^value1, Vector4 ^value2, float amount)
			{
				Vector4 ^vector;
				vector->X = value1->X + ((value2->X - value1->X) * amount);
				vector->Y = value1->Y + ((value2->Y - value1->Y) * amount);
				vector->Z = value1->Z + ((value2->Z - value1->Z) * amount);
				vector->W = value1->W + ((value2->W - value1->W) * amount);
				return vector;
			}

			void Vector4::Lerp(Vector4 ^%value1, Vector4 ^%value2, float amount, [Out] Vector4 ^%result)
			{
				result->X = value1->X + ((value2->X - value1->X) * amount);
				result->Y = value1->Y + ((value2->Y - value1->Y) * amount);
				result->Z = value1->Z + ((value2->Z - value1->Z) * amount);
				result->W = value1->W + ((value2->W - value1->W) * amount);
			}

			Vector4^ Vector4::Barycentric(Vector4 ^value1, Vector4 ^value2, Vector4 ^value3, float amount1, float amount2)
			{
				Vector4 ^vector;
				vector->X = (value1->X + (amount1 * (value2->X - value1->X))) + (amount2 * (value3->X - value1->X));
				vector->Y = (value1->Y + (amount1 * (value2->Y - value1->Y))) + (amount2 * (value3->Y - value1->Y));
				vector->Z = (value1->Z + (amount1 * (value2->Z - value1->Z))) + (amount2 * (value3->Z - value1->Z));
				vector->W = (value1->W + (amount1 * (value2->W - value1->W))) + (amount2 * (value3->W - value1->W));
				return vector;
			}

			void Vector4::Barycentric(Vector4 ^%value1, Vector4 ^%value2, Vector4 ^%value3, float amount1, float amount2, [Out] Vector4 ^%result)
			{
				result->X = (value1->X + (amount1 * (value2->X - value1->X))) + (amount2 * (value3->X - value1->X));
				result->Y = (value1->Y + (amount1 * (value2->Y - value1->Y))) + (amount2 * (value3->Y - value1->Y));
				result->Z = (value1->Z + (amount1 * (value2->Z - value1->Z))) + (amount2 * (value3->Z - value1->Z));
				result->W = (value1->W + (amount1 * (value2->W - value1->W))) + (amount2 * (value3->W - value1->W));
			}

			Vector4^ Vector4::SmoothStep(Vector4 ^value1, Vector4 ^value2, float amount)
			{
				Vector4 ^vector;
				amount = (amount > 1.0f) ? 1.0f : ((amount < 0.0f) ? 0.0f : amount);
				amount = (amount * amount) * (3.0f - (2.0f * amount));
				vector->X = value1->X + ((value2->X - value1->X) * amount);
				vector->Y = value1->Y + ((value2->Y - value1->Y) * amount);
				vector->Z = value1->Z + ((value2->Z - value1->Z) * amount);
				vector->W = value1->W + ((value2->W - value1->W) * amount);
				return vector;
			}

			void Vector4::SmoothStep(Vector4 ^%value1, Vector4 ^%value2, float amount, [Out] Vector4 ^%result)
			{
				amount = (amount > 1.0f) ? 1.0f : ((amount < 0.0f) ? 0.0f : amount);
				amount = (amount * amount) * (3.0f - (2.0f * amount));
				result->X = value1->X + ((value2->X - value1->X) * amount);
				result->Y = value1->Y + ((value2->Y - value1->Y) * amount);
				result->Z = value1->Z + ((value2->Z - value1->Z) * amount);
				result->W = value1->W + ((value2->W - value1->W) * amount);
			}

			Vector4^ Vector4::CatmullRom(Vector4 ^value1, Vector4 ^value2, Vector4 ^value3, Vector4 ^value4, float amount)
			{
				Vector4 ^vector;
				float num = amount * amount;
				float num2 = amount * num;
				vector->X = 0.5f * ((((2.0f * value2->X) + ((-value1->X + value3->X) * amount)) + (((((2.0f * value1->X) - (5.0f * value2->X)) + (4.0f * value3->X)) - value4->X) * num)) + ((((-value1->X + (3.0f * value2->X)) - (3.0f * value3->X)) + value4->X) * num2));
				vector->Y = 0.5f * ((((2.0f * value2->Y) + ((-value1->Y + value3->Y) * amount)) + (((((2.0f * value1->Y) - (5.0f * value2->Y)) + (4.0f * value3->Y)) - value4->Y) * num)) + ((((-value1->Y + (3.0f * value2->Y)) - (3.0f * value3->Y)) + value4->Y) * num2));
				vector->Z = 0.5f * ((((2.0f * value2->Z) + ((-value1->Z + value3->Z) * amount)) + (((((2.0f * value1->Z) - (5.0f * value2->Z)) + (4.0f * value3->Z)) - value4->Z) * num)) + ((((-value1->Z + (3.0f * value2->Z)) - (3.0f * value3->Z)) + value4->Z) * num2));
				vector->W = 0.5f * ((((2.0f * value2->W) + ((-value1->W + value3->W) * amount)) + (((((2.0f * value1->W) - (5.0f * value2->W)) + (4.0f * value3->W)) - value4->W) * num)) + ((((-value1->W + (3.0f * value2->W)) - (3.0f * value3->W)) + value4->W) * num2));
				return vector;
			}

			void Vector4::CatmullRom(Vector4 ^%value1, Vector4 ^%value2, Vector4 ^%value3, Vector4 ^%value4, float amount, [Out] Vector4 ^%result)
			{
				float num = amount * amount;
				float num2 = amount * num;
				result->X = 0.5f * ((((2.0f * value2->X) + ((-value1->X + value3->X) * amount)) + (((((2.0f * value1->X) - (5.0f * value2->X)) + (4.0f * value3->X)) - value4->X) * num)) + ((((-value1->X + (3.0f * value2->X)) - (3.0f * value3->X)) + value4->X) * num2));
				result->Y = 0.5f * ((((2.0f * value2->Y) + ((-value1->Y + value3->Y) * amount)) + (((((2.0f * value1->Y) - (5.0f * value2->Y)) + (4.0f * value3->Y)) - value4->Y) * num)) + ((((-value1->Y + (3.0f * value2->Y)) - (3.0f * value3->Y)) + value4->Y) * num2));
				result->Z = 0.5f * ((((2.0f * value2->Z) + ((-value1->Z + value3->Z) * amount)) + (((((2.0f * value1->Z) - (5.0f * value2->Z)) + (4.0f * value3->Z)) - value4->Z) * num)) + ((((-value1->Z + (3.0f * value2->Z)) - (3.0f * value3->Z)) + value4->Z) * num2));
				result->W = 0.5f * ((((2.0f * value2->W) + ((-value1->W + value3->W) * amount)) + (((((2.0f * value1->W) - (5.0f * value2->W)) + (4.0f * value3->W)) - value4->W) * num)) + ((((-value1->W + (3.0f * value2->W)) - (3.0f * value3->W)) + value4->W) * num2));
			}

			Vector4^ Vector4::Hermite(Vector4 ^value1, Vector4 ^tangent1, Vector4 ^value2, Vector4 ^tangent2, float amount)
			{
				Vector4 ^vector;
				float num = amount * amount;
				float num6 = amount * num;
				float num5 = ((2.0f * num6) - (3.0f * num)) + 1.0f;
				float num4 = (-2.0f * num6) + (3.0f * num);
				float num3 = (num6 - (2.0f * num)) + amount;
				float num2 = num6 - num;
				vector->X = (((value1->X * num5) + (value2->X * num4)) + (tangent1->X * num3)) + (tangent2->X * num2);
				vector->Y = (((value1->Y * num5) + (value2->Y * num4)) + (tangent1->Y * num3)) + (tangent2->Y * num2);
				vector->Z = (((value1->Z * num5) + (value2->Z * num4)) + (tangent1->Z * num3)) + (tangent2->Z * num2);
				vector->W = (((value1->W * num5) + (value2->W * num4)) + (tangent1->W * num3)) + (tangent2->W * num2);
				return vector;
			}

			void Vector4::Hermite(Vector4 ^%value1, Vector4 ^%tangent1, Vector4 ^%value2, Vector4 ^%tangent2, float amount, [Out] Vector4 ^%result)
			{
				float num = amount * amount;
				float num6 = amount * num;
				float num5 = ((2.0f * num6) - (3.0f * num)) + 1.0f;
				float num4 = (-2.0f * num6) + (3.0f * num);
				float num3 = (num6 - (2.0f * num)) + amount;
				float num2 = num6 - num;
				result->X = (((value1->X * num5) + (value2->X * num4)) + (tangent1->X * num3)) + (tangent2->X * num2);
				result->Y = (((value1->Y * num5) + (value2->Y * num4)) + (tangent1->Y * num3)) + (tangent2->Y * num2);
				result->Z = (((value1->Z * num5) + (value2->Z * num4)) + (tangent1->Z * num3)) + (tangent2->Z * num2);
				result->W = (((value1->W * num5) + (value2->W * num4)) + (tangent1->W * num3)) + (tangent2->W * num2);
			}

			Vector4^ Vector4::Transform(Vector2 position, Matrix matrix)
			{
				return gcnew Vector4();
			}

			void Vector4::Transform(Vector2 ^%position, Matrix matrix, [Out] Vector4 ^%result)
			{
			}

			Vector4^ Vector4::Transform(Vector3 position, Matrix matrix)
			{
				return gcnew Vector4();
			}

			void Vector4::Transform(Vector3  ^%position, Matrix  ^%matrix, [Out] Vector4 ^%result)
			{
			}

			Vector4^ Vector4::Transform(Vector4 ^vector, Matrix matrix)
			{
				return gcnew Vector4();
			}

			void Vector4::Transform(Vector4 ^%vector, Matrix  ^%matrix, [Out] Vector4 ^%result)
			{
			}

			Vector4^ Vector4::Transform(Vector2 value, Quaternion rotation)
			{
				return gcnew Vector4();
			}

			void Vector4::Transform(Vector2  ^%value, Quaternion  ^%rotation, [Out] Vector4 ^%result)
			{
			}

			Vector4^ Vector4::Transform(Vector3 value, Quaternion rotation)
			{
				return gcnew Vector4();
			}

			void Vector4::Transform(Vector3  ^%value, Quaternion  ^%rotation, [Out] Vector4 ^%result)
			{
			}

			Vector4^ Vector4::Transform(Vector4 ^value, Quaternion rotation)
			{
				return gcnew Vector4();
			}

			void Vector4::Transform(Vector4 ^%value, Quaternion  ^%rotation, [Out] Vector4 ^%result)
			{
			}

			void Vector4::Transform(array<Vector4> ^sourceArray, Matrix ^%matrix, array<Vector4> ^destinationArray)
			{
			}

			void Vector4::Transform(array<Vector4> ^sourceArray, int sourceIndex, Matrix ^%matrix, array<Vector4> ^destinationArray, int destinationIndex, int length)
			{
			}

			void Vector4::Transform(array<Vector4> ^sourceArray, Quaternion ^%rotation, array<Vector4> ^destinationArray)
			{
			}

			void Vector4::Transform(array<Vector4> ^sourceArray, int sourceIndex, Quaternion ^%rotation, array<Vector4> ^destinationArray, int destinationIndex, int length)
			{
			}

			Vector4^ Vector4::Negate(Vector4 ^value)
			{
				Vector4 ^vector;
				vector->X = -value->X;
				vector->Y = -value->Y;
				vector->Z = -value->Z;
				vector->W = -value->W;
				return vector;
			}

			void Vector4::Negate(Vector4 ^%value, [Out] Vector4 ^%result)
			{
				result->X = -value->X;
				result->Y = -value->Y;
				result->Z = -value->Z;
				result->W = -value->W;
			}

			Vector4^ Vector4::Add(Vector4 ^value1, Vector4 ^value2)
			{
				Vector4 ^vector;
				vector->X = value1->X + value2->X;
				vector->Y = value1->Y + value2->Y;
				vector->Z = value1->Z + value2->Z;
				vector->W = value1->W + value2->W;
				return vector;
			}

			void Vector4::Add(Vector4 ^%value1, Vector4 ^%value2, [Out] Vector4 ^%result)
			{
				result->X = value1->X + value2->X;
				result->Y = value1->Y + value2->Y;
				result->Z = value1->Z + value2->Z;
				result->W = value1->W + value2->W;
			}

			Vector4^ Vector4::Subtract(Vector4 ^value1, Vector4 ^value2)
			{
				Vector4 ^vector;
				vector->X = value1->X - value2->X;
				vector->Y = value1->Y - value2->Y;
				vector->Z = value1->Z - value2->Z;
				vector->W = value1->W - value2->W;
				return vector;
			}

			void Vector4::Subtract(Vector4 ^%value1, Vector4 ^%value2, [Out] Vector4 ^%result)
			{
				result->X = value1->X - value2->X;
				result->Y = value1->Y - value2->Y;
				result->Z = value1->Z - value2->Z;
				result->W = value1->W - value2->W;
			}

			Vector4^ Vector4::Multiply(Vector4 ^value1, Vector4 ^value2)
			{
				Vector4 ^vector;
				vector->X = value1->X * value2->X;
				vector->Y = value1->Y * value2->Y;
				vector->Z = value1->Z * value2->Z;
				vector->W = value1->W * value2->W;
				return vector;
			}

			void Vector4::Multiply(Vector4 ^%value1, Vector4 ^%value2, [Out] Vector4 ^%result)
			{
				result->X = value1->X * value2->X;
				result->Y = value1->Y * value2->Y;
				result->Z = value1->Z * value2->Z;
				result->W = value1->W * value2->W;
			}

			Vector4^ Vector4::Multiply(Vector4 ^value1, float scaleFactor)
			{
				Vector4 ^vector;
				vector->X = value1->X * scaleFactor;
				vector->Y = value1->Y * scaleFactor;
				vector->Z = value1->Z * scaleFactor;
				vector->W = value1->W * scaleFactor;
				return vector;
			}

			void Vector4::Multiply(Vector4 ^%value1, float scaleFactor, [Out] Vector4 ^%result)
			{
				result->X = value1->X * scaleFactor;
				result->Y = value1->Y * scaleFactor;
				result->Z = value1->Z * scaleFactor;
				result->W = value1->W * scaleFactor;
			}

			Vector4^ Vector4::Divide(Vector4 ^value1, Vector4 ^value2)
			{
				Vector4 ^vector;
				vector->X = value1->X / value2->X;
				vector->Y = value1->Y / value2->Y;
				vector->Z = value1->Z / value2->Z;
				vector->W = value1->W / value2->W;
				return vector;
			}

			void Vector4::Divide(Vector4 ^%value1, Vector4 ^%value2, [Out] Vector4 ^%result)
			{
				result->X = value1->X / value2->X;
				result->Y = value1->Y / value2->Y;
				result->Z = value1->Z / value2->Z;
				result->W = value1->W / value2->W;
			}

			Vector4^ Vector4::Divide(Vector4 ^value1, float divider)
			{
				Vector4 ^vector;
				float num = 1.0f / divider;
				vector->X = value1->X * num;
				vector->Y = value1->Y * num;
				vector->Z = value1->Z * num;
				vector->W = value1->W * num;
				return vector;
			}

			void Vector4::Divide(Vector4 ^%value1, float divider, [Out] Vector4 ^%result)
			{
				float num = 1.0f / divider;
				result->X = value1->X * num;
				result->Y = value1->Y * num;
				result->Z = value1->Z * num;
				result->W = value1->W * num;
			}

			Vector4^ Vector4::operator -(Vector4 ^value)
			{
				Vector4 ^vector;
				vector->X = -value->X;
				vector->Y = -value->Y;
				vector->Z = -value->Z;
				vector->W = -value->W;
				return vector;
			}

			bool Vector4::operator ==(Vector4 ^value1, Vector4 ^value2)
			{
				return ((((value1->X == value2->X) && (value1->Y == value2->Y)) && (value1->Z == value2->Z)) && (value1->W == value2->W));
			}

			bool Vector4::operator !=(Vector4 ^value1, Vector4 ^value2)
			{
				if(((value1->X == value2->X) && (value1->Y == value2->Y)) && (value1->Z == value2->Z))
				{
					return !(value1->W == value2->W);
				}
				return true;
			}

			Vector4^ Vector4::operator +(Vector4 ^value1, Vector4 ^value2)
			{
				Vector4 ^vector;
				vector->X = value1->X + value2->X;
				vector->Y = value1->Y + value2->Y;
				vector->Z = value1->Z + value2->Z;
				vector->W = value1->W + value2->W;
				return vector;
			}

			Vector4^ Vector4::operator -(Vector4 ^value1, Vector4 ^value2)
			{
				Vector4 ^vector;
				vector->X = value1->X - value2->X;
				vector->Y = value1->Y - value2->Y;
				vector->Z = value1->Z - value2->Z;
				vector->W = value1->W - value2->W;
				return vector;
			}

			Vector4^ Vector4::operator *(Vector4 ^value1, Vector4 ^value2)
			{
				Vector4 ^vector;
				vector->X = value1->X * value2->X;
				vector->Y = value1->Y * value2->Y;
				vector->Z = value1->Z * value2->Z;
				vector->W = value1->W * value2->W;
				return vector;
			}

			Vector4^ Vector4::operator *(Vector4 ^value1, float scaleFactor)
			{
				Vector4 ^vector;
				vector->X = value1->X * scaleFactor;
				vector->Y = value1->Y * scaleFactor;
				vector->Z = value1->Z * scaleFactor;
				vector->W = value1->W * scaleFactor;
				return vector;
			}

			Vector4^ Vector4::operator *(float scaleFactor, Vector4 ^value1)
			{
				Vector4 ^vector;
				vector->X = value1->X * scaleFactor;
				vector->Y = value1->Y * scaleFactor;
				vector->Z = value1->Z * scaleFactor;
				vector->W = value1->W * scaleFactor;
				return vector;
			}

			Vector4^ Vector4::operator /(Vector4 ^value1, Vector4 ^value2)
			{
				Vector4 ^vector;
				vector->X = value1->X / value2->X;
				vector->Y = value1->Y / value2->Y;
				vector->Z = value1->Z / value2->Z;
				vector->W = value1->W / value2->W;
				return vector;
			}

			Vector4^ Vector4::operator / (Vector4 ^value1, float divider)
			{
				Vector4 ^vector;
				float num = 1.0f / divider;
				vector->X = value1->X * num;
				vector->Y = value1->Y * num;
				vector->Z = value1->Z * num;
				vector->W = value1->W * num;
				return vector;
			}

			static Vector4::Vector4()
			{
				Vector4::_zero = gcnew Vector4();
				Vector4::_one = gcnew Vector4(1.0f, 1.0f, 1.0f, 1.0f);
				Vector4::_unitX = gcnew Vector4(1.0f, 0.0f, 0.0f, 0.0f);
				Vector4::_unitY = gcnew Vector4(0.0f, 1.0f, 0.0f, 0.0f);
				Vector4::_unitZ = gcnew Vector4(0.0f, 0.0f, 1.0f, 0.0f);
				Vector4::_unitW = gcnew Vector4(0.0f, 0.0f, 0.0f, 1.0f);
			}
		}
	}
}
